<?php

// $i24h_config_m3u_file_url = dirname(__FILE__) . '/iptv.utf8.m3u';

class I24hConfig
{
    const VOD_MOVIE_PAGE_SUPPORTED = true;
    const VOD_FAVORITES_SUPPORTED  = true;
    const TV_FAVORITES_SUPPORTED   = true;
    
    const BASE_URL				= 'http://api.24h.tv/';

    const CHANNEL_LIST_URL      = 'v2/channels/categories?access_token=%s&format=xml';//'v1/profile/channels2?access-token=%s&expand=lnkCnl2Ctg&_format=xml';
    const CHANNEL_USER_LIST     = 'v2/users/self/channels?access_token=%s&format=xml';
    const CHANNEL_URL           = 'v2/channels/%s/stream?ts=%s&type=%s&access_token=%s&format=xml';
   // const CHANNEL_ACTIVE_URL    = 'v1/profile/channels3?access-token=%s&active=1&_format=xml';
    const GROUP_LIST_URL      = 'v2/users/self/channels/categories?access_token=%s&format=xml';//'v1/caregory/search?access-token=%s&sort=priorety&active=1&_format=xml';

    // EPG_URL_FORMAT defines format string for the EPG-fetching-URL.
    // If it is null, EPG is not supported and will not be shown.
    const EPG_URL_FORMAT        = 'v2/channels/%s/schedule?start=%s&end=%s&access_token=%s&format=xml';//'v1/epg/epgguide?access-token=%s&channels_id=%s&sort=start&bgn=%s&end=%s&_format=xml';

    /*const TOPCAT_LIST_URL	= 'v1/xcaregory/search?access-token=%s&type=1&sort=priorety&active=1&_format=xml';
    const SUBCAT_LIST_URL	= 'v1/xcatlnk/search?access-token=%s&xcat_id=%s&sort=-cnt&expand=xcat2&_format=xml';
    const MOVIE_LIST_URL_FORMAT = 'v1/product/search?access-token=%s&xcategory=%s&sort=-bgn&expand=img&_format=xml';
    const MOVIE_SEARCH_URL	= 'v1/product/search?access-token=%s&name=%s&expand=img&sort=bgn&_format=xml';
    const MOVIE_INFO_URL_FORMAT = 'v1/product/%s?access-token=%s&expand=img&_format=xml';
    const MOVIE_SERIES_URL_FORMAT = 'v1/guide/search?access-token=%s&series_id=%s&sort=-bgn&expand=img&_format=xml';*/

    const TOPCAT_LIST_URL	= 'v2/programs/filters?access_token=%s&format=json';//'v1/epg/vcat?access-token=%s&type=1&sort=priorety&active=1&_format=xml';
    #const SUBCAT_LIST_URL	= 'v1/epg/epggenre-category?access-token=%s&category_id=%s&sort=-cnt&_format=xml';
//    const SUBCAT_LIST_URL_OLD	= 'v2/programs/filters/%s?access_token=%s&format=xml';//'v1/epg/epggenre-vcategory?access-token=%s&vcat_id=%s&sort=-cnt&_format=xml';

    const SUBCAT_LIST_URL	= 'v2/programs/filters/%s?access_token=%s&format=json';

    #const MOVIE_LIST_URL_FORMAT = 'v1/epg/epgproduct?access-token=%s&category_id=%s&genre=%s&sort=-bgn&expand=img&_format=xml';
    const MOVIE_LIST_URL_FORMAT =   'v2/programs?filters=%s&access_token=%s&limit=%s&offset=%s&format=xml'; //'v1/epg/epgproduct?access-token=%s&vcat_id=%s&genre=%s&sort=-bgn&expand=img&_format=xml';
    const MOVIE_SEARCH_URL	=       'v2/search?text=%s&access_token=%s&limit=%s&offset=%s&format=xml';//'v1/epg/epgproduct?access-token=%s&name=%s&expand=img&sort=bgn&_format=xml';
    const MOVIE_INFO_URL_FORMAT =   'v2/programs/%s?access_token=%s&format=xml';//'v1/epg/epgproduct-view/%s?access-token=%s&expand=img&_format=xml';
    const MOVIE_INFO_URL_FORMAT_JSON =   'v2/programs/%s?access_token=%s&format=json';//'v1/epg/epgproduct-view/%s?access-token=%s&expand=img&_format=xml';

    const MOVIE_SERIES_URL_FORMAT = 'v2/programs/%s/schedule?access_token=%s&format=xml';//'v1/epg/epgguide?access-token=%s&product_id=%s&sort=-start&expand=img&_format=xml';
    
    const VIDEO_GENRE_LIST = 'v2/videos/filters?access_token=%s&format=xml';//'v1/vod/genres?access-token=%s&_format=xml';
    const VIDEO_TOP_LIST = 'v2/promotions?access_token=%s&format=xml';//'v1/vod/serials?access-token=%s&top=1&active=1&_format=xml';
    const VIDEO_TOP_SERIAL_INFO = 'v2/videos/%s?access_token=%s&includes=episodes&format=xml';
    const VIDEO_SERIALS_LIST = 'v2/videos?access_token=%s&filters=%s&limit=%s&offset=%s&format=xml';//'v2/videos?includes=episodes&access_token=%s&filters=%s&limit=%s&offset=%s&format=xml';  // 'v1/vod/serials?access-token=%s&genre_id=%s&active=1&_format=xml';

    const VIDEO_SERIES_LIST = 'v2/videos/%s/episodes?access_token=%s&format=xml';//'v1/vod/video?access-token=%s&vodSeason_id=%s&sort=n&active=1&_format=xml';
    const VIDEO_EPISODES_URL = 'v2/videos/%s/episodes/%s/stream?type=%s&access_token=%s&format=xml';
    const VIDEO_SERIAL = 'v2/videos/%s?access_token=%s&format=xml';//'v1/vod/serials-view/%s?access-token=%s&expand=seasons&_format=xml';
    const VIDEO_ALLOW = 'v2/users/self/subscriptions/current?includes=packet.videos&access_token=%s&format=xml';
    const VIDEO_IN_PACKETS = 'v2/packets?includes=videos&access_token=%s&format=xml';
    const CHANNEL_IN_PACKET = 'v2/packets?includes=channels&access_token=%s&format=xml';

    const VOD_CATEGORIES_URL    = 'http://online.dune-hd.com/i24h2/vod_categories.pl'; 
    //const MOVIE_LIST_URL_FORMAT = 'http://online.dune-hd.com/i24h2/movie_list.pl?category_id=%s';
    //const MOVIE_INFO_URL_FORMAT = 'http://online.dune-hd.com/i24h2/movie_info.pl?movie_id=%s';

    
    const ALL_CHANNEL_GROUP_CAPTION     = 'Все каналы';
    //const ALL_CHANNEL_GROUP_ICON_PATH   = 'plugin_file://icons/all.png';
    const ALL_CHANNEL_GROUP_ICON_PATH   = 'http://static.24h.tv/dune/channel/All.jpg';
    const ALL_CHANNEL_GROUP_PANEL_ICON_PATH   = 'http://static.24h.tv/dune/channel/PanelAll.png';

    const FAV_CHANNEL_GROUP_CAPTION     = 'Избранное';
    //const FAV_CHANNEL_GROUP_ICON_PATH   = 'plugin_file://icons/fav.png';
    const FAV_CHANNEL_GROUP_ICON_PATH   = 'http://static.24h.tv/dune/channel/Fav.jpg';
    const FAV_CHANNEL_GROUP_PANEL_ICON_PATH   = 'http://static.24h.tv/dune/channel/PanelFav.png';

    const FAV_MOVIES_CATEGORY_CAPTION   = 'Избранное';
    const FAV_MOVIES_CATEGORY_ICON_PATH = 'plugin_file://icons/fav.png';

    // NOTE: see also comments in dune_plugin.xml
    const USE_M3U_FILE = false;

    // const M3U_FILE_URL = $i24h_config_m3u_file_url;
    const M3U_FILE_URL = 'http://online.dune-hd.com/i24h2/m3u/iptv.utf8.m3u';

    // const M3U_ICON_FILE_URL_FORMAT = 'plugin_file://icons/%s.aai';
    const M3U_ICON_FILE_URL_FORMAT = 'http://online.dune-hd.com/i24h2/m3u/%s.aai';

    // CHANNEL_SORT_FUNC_CB defines the function name to be used as a callback
    // to sort IPTV-channels.
    //
    // If it is null, sorting will not be performed.
    const CHANNEL_SORT_FUNC_CB = 'I24hConfig::sort_channels_cb';
    const BG_PIC = 'plugin_file://img/screen.png';
    //const BG_PIC = 'http://24h.tv/tv/test/background.png';


    ///////////////////////////////////////////////////////////////////////
    // How to sort IPTV-channels.

/*    public static function sort_channels_cb($a, $b)
    {
        // Sort by channel numbers.
        return strnatcasecmp($a->get_number(), $b->get_number());

        // Other options:
        // return strnatcasecmp($a->get_title(), $b->get_title());
    }
*/
    ///////////////////////////////////////////////////////////////////////
    // Folder views.

    public static function GET_TV_GROUP_LIST_FOLDER_VIEWS()
    {
        hd_print("/////// GET_TV_GROUP_LIST_FOLDER_VIEWS");
        return array(
            /*array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 4,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),*/
            
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 4,//4,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 320,//395,
                    ViewParams::sandwich_height => 168,//220,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                        ViewItemParams::icon_width => 320,//395,
                        ViewItemParams::icon_height => 168,//220,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            /*array
            (
                array
                (
                    PluginRegularFolderView::async_icon_loading => false,

                    PluginRegularFolderView::view_params => array
                    (
                        ViewParams::num_cols => 4,
                        ViewParams::num_rows => 3,
                        ViewParams::paint_details => false,
                        ViewParams::paint_sandwich => false,

                    ),

                    PluginRegularFolderView::base_view_item_params => array
                    (
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::item_layout => HALIGN_CENTER,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550,
                        ViewItemParams::icon_width => 395,
#                        ViewItemParams::icon_height => 185,
                        ViewItemParams::icon_height => 220,
                        ViewItemParams::item_paint_caption => false,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai'

                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array (),
                )
            )*/


        );
    }

    public static function GET_TV_CHANNEL_LIST_FOLDER_VIEWS()
    {
        hd_print("/////// GET_TV_CHANNEL_LIST_FOLDER_VIEWS");
        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 4,
                    ViewParams::paint_details => false,
//                    ViewParams::paint_sandwich => true,
//                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
//                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
//                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                    ViewItemParams::icon_path => 'plugin_file://icons/channel_unset.png'
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 2,
                    ViewParams::num_rows => 15,
                    ViewParams::paint_details => true,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::icon_width => 40,
                    ViewItemParams::icon_height => 30,
                    ViewItemParams::item_caption_width => 525,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_SMALL,
                    ViewItemParams::icon_path => 'plugin_file://icons/channel_unset.png',
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 4,//3,
                    ViewParams::paint_details => false,
/*                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',*/
                    ViewParams::sandwich_width => 290,//395,
                    ViewParams::sandwich_height => 160,//220,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                        ViewItemParams::icon_width => 290,//395,
                        ViewItemParams::icon_height => 160,//220,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 4,
                    ViewParams::paint_details => true,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                    ViewItemParams::icon_path => 'plugin_file://icons/channel_unset.png',
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                    ViewItemParams::icon_path => 'plugin_file://icons/channel_unset.png',
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            )
        );
    }

    public static function GET_VOD_MOVIE_LIST_FOLDER_VIEWS()
    {
        hd_print("/////// GET_VOD_MOVIE_LIST_FOLDER_VIEWS");
    	return array(
    	    array
    	    (
    	    	PluginRegularFolderView::async_icon_loading => true,
    	    	
    	    	PluginRegularFolderView::view_params => array
    	    	(
    	    	    ViewParams::num_cols => 4,
    	    	    ViewParams::num_rows => 2,
    	    	    ViewParams::paint_details => false,
    	    	    ViewParams::orientation  => 'horizontal',
    	    	    ViewParams::sandwich_width => 380,//290,//380,
    	    	    ViewParams::sandwich_height => 240,//160,//240,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
    	    	    
    	    	    //ViewParams::background_path => self::BG_PIC,
    	    	    //ViewParams::background_width => 1920,
    	    	    //ViewParams::background_height => 1080,
    	    	    //ViewParams::background_order => 'before_all'
    	    	    ),     
    	    	
    	    	PluginRegularFolderView::base_view_item_params => array
    	    	(      
    	    	    ViewItemParams::item_paint_icon => true,
    	    	    ViewItemParams::item_layout => HALIGN_CENTER,
    	    	    ViewItemParams::icon_valign => VALIGN_TOP,
    	    	    ViewItemParams::item_paint_caption => true,
    	    	    ViewItemParams::icon_scale_factor => 1.0,
    	    	    ViewItemParams::item_caption_wrap_enabled => true,
    	    	    ViewItemParams::item_caption_dy => -40,
    	    	    ViewItemParams::item_caption_sel_dy => -40,
    	    	    ViewItemParams::icon_dy => 7,
    	    	    ViewItemParams::icon_sel_dy => 7,


    	    	    ),
    	    	PluginRegularFolderView::not_loaded_view_item_params => array
    	    	(
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
                    ViewItemParams::item_detailed_icon_path => 'missing://',
//    	    	    ViewItemParams::icon_path => 'plugin_file://icons/placeholder.png',
    	    	    ),
    	    	),
    	    
    	    );
        /*return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 6,
                    ViewParams::num_rows => 3,
                    ViewParams::icon_selection_box_width => 150,
                    ViewParams::icon_selection_box_height => 222,
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_padding_top => 0,
                    ViewItemParams::item_padding_bottom => 0,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array
                (
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
                    ViewItemParams::item_detailed_icon_path => 'missing://',
                ),
            ));*/
    }

    public static function GET_VOD_CATEGORY_LIST_FOLDER_VIEWS()
    {
       // hd_print("/////// GET_VOD_CATEGORY_LIST_FOLDER_VIEWS");
        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 4,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );
    }
    
    public static function GET_PRIVATE_FOLDER_VIEWS_OLD()
    {
        hd_print("/////// GET_PRIVATE_FOLDER_VIEWS");
            return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 8,
                    ViewParams::paint_details => true,
                    ViewParams::content_box_padding_top => 86,
                    ViewParams::content_box_padding_bottom => 170,
                    ViewParams::extra_content_objects =>

                    'label{x=93}{y=30}{text=Подписки:}{color=15}'.
                    'label{x=50}{y=644}{text=Посмотреть состав пакета - нажмите INFO}{color=15}'.
                    'label{x=50}{y=688}{text=Информация о сервисе - на сайте 24h.tv}{color=15}',
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -7,
                    ViewItemParams::item_caption_width => 1105,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );

    }

    public static function GET_PRIVATE_FOLDER_VIEWS()
    {
        hd_print("/////// GET_PRIVATE_FOLDER_VIEWS");
            return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 8,
                    ViewParams::paint_details => true,
                    ViewParams::content_box_padding_top => 86,
                    ViewParams::content_box_padding_bottom => 170,
                    ViewParams::extra_content_objects =>

                    'label{x=93}{y=30}{text=Тарифы:}{color=15}'.
                    'label{x=50}{y=644}{text=Посмотреть состав пакета - нажмите INFO}{color=15}'.
                    'label{x=50}{y=688}{text=Информация о сервисе - на сайте 24h.tv}{color=15}',
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -7,
                    ViewItemParams::item_caption_width => 1105,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );

    }

    public static function GET_ADDPACKETS_FOLDER_VIEWS()
    {
        hd_print("/////// GET_ADDPACKETS_FOLDER_VIEWS");
            return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 8,
                    ViewParams::paint_details => true,
                    ViewParams::content_box_padding_top => 86,
                    ViewParams::content_box_padding_bottom => 170,
                    ViewParams::extra_content_objects =>

                    'label{x=93}{y=30}{text=Дополнительные пакеты:}{color=15}'.
                    'label{x=50}{y=644}{text=Посмотреть состав пакета - нажмите INFO}{color=15}'.
                    'label{x=50}{y=688}{text=Информация о сервисе - на сайте 24h.tv}{color=15}',
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -7,
                    ViewItemParams::item_caption_width => 1105,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );

    }

    public static function GET_DEVICE_LIST_FOLDER_VIEWS(){
        hd_print("/////// GET_DEVICE_LIST_FOLDER_VIEWS");
        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 8,
                    ViewParams::paint_details => true,
                    ViewParams::content_box_padding_top => 150,
//                    ViewParams::content_box_padding_bottom => 170,
                    ViewParams::extra_content_objects =>
                        'label{x=50}{y=30}{text=Превышен лимит устройств на учетную запись (5 штук)!}{color=15}'.
                        'label{x=50}{y=80}{text=Выберите устройство, которое необходимо удалить:}{color=15}'.
                        'label{x=50}{y=730}{text=Текущее устройство заменит удаленное!}{color=15}',
//                        'label{x=50}{y=688}{text=Информация о сервисе - на сайте 24h.tv}{color=15}',
                    ViewParams::background_path => self::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -7,
                    ViewItemParams::item_caption_width => 1105,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );
    }

    public static function GET_VOD_GENRES_IMG($name){
        $arr =  array(
            'Амедиатека / Детектив'=>'http://static.24h.tv/dune/vod/genres/detektiv.png',
            'Амедиатека / Комедия'=>'http://static.24h.tv/dune/vod/genres/comedia.png',
            'Амедиатека / Драма'=>'http://static.24h.tv/dune/vod/genres/drama.png',
            'Амедиатека / Эротика'=>'http://static.24h.tv/dune/vod/genres/erotik.png',
            'Амедиатека / Фэнтези'=>'http://static.24h.tv/dune/vod/genres/fantasy.png',
            'Амедиатека / Исторический'=>'http://static.24h.tv/dune/vod/genres/history.png',
            'Амедиатека / Реалити'=>'http://static.24h.tv/dune/vod/genres/reality.png',
            'Амедиатека / Триллер'=>'http://static.24h.tv/dune/vod/genres/triller.png',
            'Амедиатека / Документальный'=>'http://static.24h.tv/dune/vod/genres/Documents.jpg',
            'Амедиатека / Музыка'=>'http://static.24h.tv/dune/vod/genres/Music.jpg',
            'Амедиатека / Мультфильм'=>'http://static.24h.tv/dune/vod/genres/Multik.jpg',
            'Амедиатека / Фантастика'=>'http://static.24h.tv/dune/vod/genres/Fantastik.jpg',
            'Амедиатека / Тележурнал'=>'http://static.24h.tv/dune/vod/genres/Telejurnal.jpg',
            'ЦТ Премьера / Избранное'=>'http://static.24h.tv/dune/vod/genres/CTfavorites.jpg',
            'ЦТ Премьера / Дети'=>'http://static.24h.tv/dune/vod/genres/CTdeti.jpg',
            'ЦТ Премьера / Познание'=>'http://static.24h.tv/dune/vod/genres/CTPoznanie.jpg',
            'ЦТ Премьера / Русский роман'=>'http://static.24h.tv/dune/vod/genres/CTrusroman.jpg',
            'ЦТ Премьера / Кино'=>'http://static.24h.tv/dune/vod/genres/CTkino.jpg',
        );
        return empty($arr[$name])?'http://static.24h.tv/dune/vod/genres/nophoto.png':$arr[$name];
    }

    public static function GET_ARCH_GENRES_LIST(){
        return array(
            '1'=>'http://static.24h.tv/dune/main/ArchiveFilm.png',
            '2'=>'http://static.24h.tv/dune/main/ArchiveSerials.png',
            '3'=>'http://static.24h.tv/dune/main/ArchiveBaby.png',
            '4'=>'http://static.24h.tv/dune/main/ArchivePeredachi.png',
            '5'=>'http://static.24h.tv/dune/main/ArchiveSport.png',
        );
    }

}

?>
