<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';


class I24hDeviceListScreen extends /*AbstractControlsScreen*/  AbstractPreloadedRegularScreen
    implements UserInputHandler
{
    const ID = 'device_list';

    public static function get_media_url_str()
    {
        return MediaURL::encode(
            array('screen_id' => self::ID));
    }


    public static function get_item_media_url_str($device_id)
    {
        return MediaURL::encode(
            array(
                'screen_id' => self::ID,
                'device' => $device_id
            ));
    }


    public function get_handler_id()
    {
        return self::ID;
    }


    private /* I24hPlugin */ $plugin;
    private $session;

    public function __construct(I24hPlugin $plugin, $session)
    {
        parent::__construct(self::ID, I24hConfig::GET_DEVICE_LIST_FOLDER_VIEWS());

        $this->plugin = $plugin;
        $this->session = $session;

        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }


    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
//        hd_print('Device List: handle_user_input:'.print_r($user_input,true));
//        hd_print('plugin_cookies: '.print_r($plugin_cookies,true));

        if ($user_input->handler_id == 'device_list' && $user_input->control_id == 'handle_enter'){
            $m  = MediaURL::decode($user_input->selected_media_url);
            hd_print('Unregister devide_id='.$m->device);

            if (!$this->session->delete_device($m->device)){
                return ActionFactory::show_error(false,'Ошибка удаления устройства');
            }

        }
        $reg_dev = $this->session->register_device($plugin_cookies);
        if ($reg_dev){


            $media_url = MediaURL::encode(
                array(
                    'screen_id' => self::ID,
                    'device' => null
                ));

            $items = $this->get_all_folder_items(
                $media_url, $plugin_cookies);

            hd_print("FOLDER ITEMS: ".print_r($items,true));

            return ActionFactory::update_regular_folder(
                HD::create_regular_folder_range($items), true);


//             ActionFactory::show_error(false,'Ошибка регистрации устройства');
//            return ActionFactory::open_folder(MediaURL::encode(array('screen_id'=>I24hDeviceListScreen::ID)),'24часаТВ');
        }


        // Go to main screen !
        //$post_action =
            return ActionFactory::open_folder(MediaURL::encode(array('screen_id'=>I24hTopScreen::ID)),'24часаТВ');
        //$post_action = ActionFactory::close_dialog_and_run($post_action);
        //return ActionFactory::show_main_screen($post_action);

            //array(
            //'need_close_dialog' => true,
            //'action' =>
            ///$post_action = $res['action'];
                //return ActionFactory::show_main_screen($post_action);
            //    ActionFactory::open_folder(MediaURL::encode(array('screen_id'=>'top_list')));//);

    }


    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
     //   $session = $this->plugin->get_session($plugin_cookies);
//        $session->ensure_logged_in($plugin_cookies);

        $items = array();



        $devices = $this->session->get_device_list();

//        hd_print("LIST DEVICES: ".print_r($devices,true));

        foreach ($devices as $dev){
            $items[] = array
            (
                PluginRegularFolderItem::media_url =>
                    self::get_item_media_url_str($dev->id),
                PluginRegularFolderItem::caption => '['.$dev->device_type.'] - '.$dev->vendor.' '.$dev->model.' '. !empty($dev->login_at)?', '.date("H:i d.m.y",strtotime($dev->login_at)):'',
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => 'gui_skin://large_icons/tv.aai',
                    ViewItemParams::icon_scale_factor => 0.35,
                    ViewItemParams::item_detailed_icon_path => 'gui_skin://large_icons/tv.aai',
                    ViewItemParams::item_detailed_info =>
                        (!empty($dev->model)?"Модель:||".$dev->model.'||':'').
                        (!empty($dev->device_type)?"Тип устройства: ".$dev->device_type."||":'').
                        (!empty($dev->vendor)?"Vendor: ".$dev->vendor."||":'').
                        (!empty($dev->created_at)?"Дата регистрации:||".date("H:i d.m.y",strtotime($dev->created_at))."||":'').
                        (!empty($dev->login_at)?"Дата последнего входа:||".date("H:i d.m.y",strtotime($dev->login_at))."||":'').
                        (!empty($dev->version)?"Version:||".$dev->version."||":'').
                        (!empty($dev->serial)?"Serial:||".$dev->serial:'')
                )
            );
        }


/*
 *
 *
            [id] => 00000000-460a-1389-c014-9008ea6149e5
            [device_type] => tv
            [vendor] => DUNE
            [model] => tv102v2
            [version] => 150721_0135_b9
            [serial] => 00000000460A1389C0149008EA6149E5
            [created_at] => 2017-04-24T14:07:07.441602Z
            [login_at] => 2017-05-14T15:03:39.257752Z
 *
 *
 *         $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                self::get_item_media_url_str($media_url->pin, 'service', $srv->id),
            PluginRegularFolderItem::caption => $srv->name . ($start_time ? ' (с '.$start_time.')' : ($finish_time ? ' (до '.$finish_time.')' : '')),
            PluginRegularFolderItem::view_item_params => array
            (
                ViewItemParams::icon_path => $icon_url,
                ViewItemParams::icon_scale_factor => $icon_scale_factor,
                ViewItemParams::item_detailed_icon_path => 'gui_skin://large_icons/tv.aai',
                ViewItemParams::item_detailed_info => $item_detailed_info,
            )
        );
*/


        return $items;
    }


    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        return array
        (
            GUI_EVENT_KEY_ENTER =>
                UserInputHandlerRegistry::create_action(
                    $this, 'handle_enter'),
            GUI_EVENT_KEY_INFO =>
                UserInputHandlerRegistry::create_action(
                    $this, 'handle_info'),
        );
    }

}