<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/user_input_handler_registry.php';

class I24hEntryHandler
    implements UserInputHandler
{
    private $session;

    public function __construct($session)
    {
        $this->session = $session;

        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_handler_id()
    {
        return 'entry';
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Entry handler: handle_user_input:');
        foreach ($user_input as $key => $value) hd_print("  $key => $value");


        if (!empty($user_input->control_id)) {

            if ($user_input->handler_id === 'entry' && $user_input->control_id === 'get_sms') {

                $res = $this->session->get_password($plugin_cookies, $user_input, $this);
                return $res['action'];

            } else if ($user_input->handler_id === 'entry' && $user_input->control_id === 'apply_subscription') {
                $res = $this->session->apply_subscription($plugin_cookies, $user_input,$this);
                return $res['action'];
            }

        }


        if (!isset($user_input->entry_id))
            return null;

        $add_params = array(
            'entry_id' => $user_input->entry_id);

        if ($user_input->entry_id === 'setup' ||
            $user_input->entry_id === 'tv' ||
            $user_input->entry_id === 'top')
        {
            $res = $this->session->apply_subscription(
                $plugin_cookies, $user_input,$this);

         //   hd_print("apply_subscription res: ".$res);
            if (!$res) {
                try
                {
                    $res = $this->session->get_password(
            		$plugin_cookies, $user_input, $this);
                }
                catch (DuneException $e)
                {
                    return $e->get_error_action();
                }
            }

            if ($res !== false)
            {
                if (!isset($res['action']))
                {
                    return ActionFactory::close_dialog_and_run(
                        ActionFactory::open_folder());
                }

                return $res['need_close_dialog'] ?
                    ActionFactory::close_dialog_and_run($res['action']) :
                    $res['action'];
            }
            else
            {
            	//$res = $this->session->get_password($plugin_cookies, $user_input);

                if ($this->session->is_logged_in())
                    return ActionFactory::open_folder();

                if (!$this->session->is_logged_in())
                //if (!isset($plugin_cookies->password) ||
                //    $plugin_cookies->password === '')
                {
                 //   hd_print("to verify_device");
                    $this->session->verify_device();

                    if (!$this->session->is_logged_in())
                        // go to subscriber info
	                    return $this->session->do_get_edit_subscription_action(
	                    	$plugin_cookies, $this, $add_params);
                }

                return ActionFactory::open_folder();
            }
        }

        return null;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
