<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class I24hSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';
    private $session;
    private $plugin;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($plugin, $session)
    {
        parent::__construct(self::ID);
        $this->session = $session;
        $this->plugin = $plugin;
    }

    public function get_handler_id(){
        return self::ID;
    }

    public function do_get_parent_control_defs($defs)
    {
       // $defs = array();
        $pin_control = '';
        $this->add_text_field($defs,
            'pin_control', 'Пароль родительского контроля:',
            $pin_control, 1, 1, 0, 1, 500, 0, true);

        return $defs;
    }


    public function do_get_pin_control_defs(&$plugin_cookies)
    {
        $defs = array();
        $pin1 = '';
        $pin2 = '';
        $this->add_text_field($defs,
            'pin1', 'Текущий пароль:',
            $pin1, 1, 1, 0, 1, 500, 0, false);
        $this->add_text_field($defs,
            'pin2', 'Новый пароль:',
            $pin2, 1, 1, 0, 1, 500, 0, false);

        $need_password_sextv = isset($plugin_cookies->need_password_sextv) ?
            $plugin_cookies->need_password_sextv : 'yes';

        $this->add_combobox($defs,
            'password_for_sextv', 'Блокировать телеканалы для взрослых',
            $need_password_sextv, array("yes"=>"Да","no"=>"Нет"), 0, true);

        $need_password_tariff = isset($plugin_cookies->need_password_tariff) ?
            $plugin_cookies->need_password_tariff : 'no';

        $this->add_combobox($defs,
            'password_for_tariff', 'Блокировать управление тарифами',
            $need_password_tariff, array("yes"=>"Да","no"=>"Нет"), 0, true);

   //     ControlFactory::add_label($defs, '', '');
        $pin_apply = UserInputHandlerRegistry::create_action($this, 'pin_apply', array('action_type'=>'close_window'));
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'pin_apply', 'ОК', 300, $pin_apply);
 //       ControlFactory::add_close_dialog_button($defs,
 //           'Отмена', 300);

        return $defs;
    }

    public function do_get_control_defs(&$plugin_cookies)
    {



       // $defs = array();

       // $defs = $this->do_get_pin_control_defs($plugin_cookies);

       //$defs = ;

/*        return  ActionFactory::show_dialog
        (
            "Родительский контроль",
            $this->do_get_pin_control_defs($plugin_cookies),
            true
        );
*/
        $defs = array();


        $user_name = isset($plugin_cookies->user_name) ?
            $plugin_cookies->user_name : '';

        $logged_in = $this->session->is_logged_in();

        $show_tv = isset($plugin_cookies->show_tv) ?
            $plugin_cookies->show_tv : 'yes';
        $show_vod = isset($plugin_cookies->show_vod) ?
            $plugin_cookies->show_vod : 'yes';


//        $this->add_label($defs,'Профиль:','');

        $this->add_button($defs,'show_agreement','Пользовательское соглашение','Показать',500);
        $this->add_button($defs,'show_terms','Правила пользования сервисом','Показать',0);

        $this->add_vgap($defs,30);

        $this->add_button($defs,'edit_subscription','Учетная запись: +'. $this->session->get_phone(),'Отвязать',0);

        $this->add_vgap($defs,30);

        $this->add_button($defs,'edit_tariff','Управление тарифами','Изменить',0);

//        $this->add_vgap($defs,30);

        $this->add_button($defs,'get_password','Родительский контроль','Изменить',0);
//        $this->add_button($defs,'tariff','Запрос пароля','Изменить',0);

        $this->add_vgap($defs,30);

//        $this->add_label($defs,'Настройки видео:','');


        $streams_ops = array();
        $streams_ops['local'] = 'UDP оригинальный';
        $streams_ops['local_low'] = 'UDP сжатый';
        $streams_ops['hls'] = 'HLS';

        $stream_type = isset($plugin_cookies->stream_type) ? $plugin_cookies->stream_type : 'udp';
        
        $this->add_combobox($defs,
            'stream_type', 'Формат вещания',
            $stream_type, $streams_ops, 0, true);

        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';

        $this->add_combobox($defs,
            'show_tv', 'Показывать иконку в разделе ТВ',
            $show_tv, $show_ops, 0, true);

        $this->add_vgap($defs,30);

        $this->add_label($defs,'IP адрес устройства',$this->session->get_ip_address()." (".$this->session->get_provider_name().")");
        $sup_phone = $this->session->get_support_phone();
        $sup_url   = $this->session->get_support_url();
        $sup_email = $this->session->get_support_email();

        $ar = array();
        if (!empty($sup_phone)) $ar[] = $sup_phone;
        if (!empty($sup_url)) $ar[] = $sup_url;
        if (!empty($sup_email)) $ar[] = $sup_email;
        $supp_text = implode(" / ", $ar);

//        hd_print("SUPPORT URL = ".$sup_url);

        $this->add_label($defs,'Техническая подержка', $supp_text);

        /*$this->add_combobox($defs,
            'show_vod', 'Show VOD in main screen:',
            $show_vod, $show_ops, 0, true);*/

//        $this->add_button($defs, 'edit_subscription', null,
//            'Подписка...', 0);
       // $s = array('action_type' => 'times');
       // $this->handle_user_input($s,$plugin_cookies);
        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        //
        return $this->do_get_control_defs($plugin_cookies);

    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
      //  hd_print('Setup: handle_user_input:');
      //  foreach ($user_input as $key => $value)
       //     hd_print("  $key => $value");

        $need_close_dialog = false;
        $need_reset_controls = false;
        $post_action = null;

        hd_print("ACTION TYPE ".$user_input->action_type);
        hd_print("CONTROL ID  ".$user_input->control_id);

        if ($user_input->action_type === 'apply')
        {
            $control_id = $user_input->control_id;

            if ($control_id === 'edit_subscription') {
                $defs = array();

                $this->add_close_dialog_and_apply_button($defs, 'change_subscriber', 'Да', 250);
                $this->add_close_dialog_button($defs, 'Нет', 250);
                return ActionFactory::show_dialog("Вы уверены, что хотите отвязать учетную запись?", $defs, true);
            }

            else if ($control_id === 'change_subscriber') {

                if ($this->session->delete_device($this->session->get_device_id())){
                        $this->session->unset_login();
                        $this->session->logout();
                        unset($plugin_cookies->user_name);
                        unset($plugin_cookies->user_password);

                        //$this->plugin->close_session();

                         return $this->session->do_get_edit_subscription_action(
                              $plugin_cookies, $this);

                }


            }
            else if ($control_id === 'reg_show_agreement') {

                $res = $this->session->show_user_agreement($plugin_cookies, $user_input, $this);
                return $res['action'];

            }
            else if ($control_id === 'pin_apply_subscription') {
                if ($user_input->pin == $this->session->get_parental_code()){
               //     return $this->session->do_get_edit_subscription_action(
               //         $plugin_cookies, $this);
                }else{
                    return ActionFactory::show_error(false,
                        'Ошибка!',
                        array('Введен неверный пароль от родительского контроля!'));
                }
            }

            else if ($control_id === 'edit_subscription')
            {
                return $this->session->do_get_edit_subscription_action(
                    $plugin_cookies, $this);
            }
            else if ($control_id == 'show_agreement') {
                $doc = HD::http_get_document($this->session->get_agreement());
//                ControlFactory::add_img_label($defs, '', '<icon>gui_skin://special_icons/controls_button_p_minus.aai</icon><text dy="7" size="small"> - перемотка вверх. </text><icon>gui_skin://special_icons/controls_button_p_plus.aai</icon><text dy="7" size="small"> - перемотка вниз.</text>', 0, 0, 0);
                ControlFactory::add_multiline_label($defs, '', 'Управление: "P+" - перемотка вверх, "P-" - перемотка вниз.'."\n\n".$doc, 17);
                ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
                return ActionFactory::show_dialog('Пользовательское соглашение.', $defs, true, 1800);

            }
            else if ($control_id == 'show_terms') {
                $doc = HD::http_get_document($this->session->get_terms());
//                ControlFactory::add_img_label($defs, '', '<icon>gui_skin://special_icons/controls_button_p_minus.aai</icon><text dy="7" size="small"> - перемотка вверх. </text><icon>gui_skin://special_icons/controls_button_p_plus.aai</icon><text dy="7" size="small"> - перемотка вниз.</text>', 0, 0, 0);
                ControlFactory::add_multiline_label($defs, '', 'Управление: "P+" - перемотка вверх, "P-" - перемотка вниз.'."\n\n".$doc, 17);
                ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
                return ActionFactory::show_dialog('Правила пользования сервисом.', $defs, true, 1800);

            }
            else if ($control_id == 'edit_tariff'){
                $ch_tar = !empty($plugin_cookies->need_password_tariff)?$plugin_cookies->need_password_tariff:'no';
                if ($ch_tar == 'yes') {
                    $defs = array();
                    $this->add_text_field($defs,
                        'pin', 'Пароль:',
                        '', 1, 1, 0, 1, 500, 0, false);
                    $this->add_close_dialog_and_apply_button($defs, 'apply_change_tariff', 'Применить', 250);
                    return ActionFactory::show_dialog("Родительский контроль", $defs, true);
                }else{
                    hd_print("Go change tariff");
                    return ActionFactory::open_folder(I24hPrivateScreen::get_media_url_str(''),'Управление тарифами');
                }

            }
            else if ($control_id == 'apply_change_tariff'){
                if (!empty($user_input->pin) && ($user_input->pin === $this->session->get_parental_code())){
                    hd_print("Go change tariff");
                    return ActionFactory::open_folder(I24hPrivateScreen::get_media_url_str(''),'Управление тарифами');
                }else{
                    return ActionFactory::show_error(false,
                        'Ошибка!',
                        array('Введен неверный пароль от родительского контроля!'));
                }
            }
            //show_terms

            else if ($control_id === 'apply_subscription')
            {

                hd_print("apply_subscription !!!!!!!!!!");
                if ($user_input->user_name === '')
                {
                    return ActionFactory::show_error(false,
                        'Error',
                        array('Subscription should be non-empty.'));
                }

                $plugin_cookies->user_name = $user_input->user_name;
                $plugin_cookies->password = $user_input->password;


                $res = $this->session->apply_subscription($plugin_cookies, $user_input,$this);
                $need_close_dialog = true;
                $need_reset_controls = true;
                $post_action = $res['action'];
                return ActionFactory::show_main_screen($post_action);
                ///hd_print("this->session->logout!!!!!!!!!!");
                //$this->session->logout();
            /*    api_login
                try
                {
                    $this->session->try_login($plugin_cookies);
                }
                catch (DuneException $e)
                {
                    $post_action = $e->get_error_action();
                    $plugin_cookies->password = '';
                }

                $need_close_dialog = true;
                $need_reset_controls = true;

                $post_action = ActionFactory::open_folder(MediaURL::encode(array('screen_id'=>I24hTopScreen::ID)));
                ActionFactory::close_dialog_and_run($post_action);
*/
            }
            else if ($control_id === 'password_for_sextv'){


                return null;}
            else if ($control_id === 'password_for_tariff'){return null;}



            else if ($control_id === 'get_password')
            {
                $defs =  $this->do_get_pin_control_defs($plugin_cookies);
                return ActionFactory::show_dialog("Родительский контроль", $defs, true);
                /*
                try
                {
            	    $res = $this->session->get_password($plugin_cookies, $user_input);
                }
                catch (DuneException $e)
                {
                    return $e->get_error_action();
                }
                $need_close_dialog = $res['need_close_dialog'];
                $need_reset_controls = $res['need_close_dialog'];
                return $res['action'];
            	  */
            }
            else if ($control_id === 'get_sms')
            {

                hd_print("Pressed button get_sms");
                try
                {
            	    $res = $this->session->get_password($plugin_cookies, $user_input, $this);
                }
                catch (DuneException $e)
                {
                    return $e->get_error_action();
                }
                $need_close_dialog = $res['need_close_dialog'];
                $need_reset_controls = $res['need_close_dialog'];
                return $res['action'];
            }
        } else if ($user_input->action_type === 'confirm')
        {

            $control_id = $user_input->control_id;

            if ($control_id === 'password_for_sextv'){
         //       hd_print("set plugin_cookies->need_password_sextv to ".$user_input->password_for_sextv);
         //       $plugin_cookies->need_password_sextv = $user_input->password_for_sextv;
                return null;
            }
            else if ($control_id === 'password_for_tariff'){
         //       hd_print("set plugin_cookies->need_password_tariff to ".$user_input->password_for_tariff);
         //       $plugin_cookies->need_password_tariff = $user_input->password_for_tariff;
                return null;

            }
            else if ($control_id === 'get_password'){return null;}else {


                $control_id = $user_input->control_id;
                $new_value = $user_input->{$control_id};
                hd_print("Setup: changing $control_id value to $new_value");

                if ($control_id === 'show_tv')
                    $plugin_cookies->show_tv = $new_value;
                else if ($control_id === 'stream_type') {
                    $plugin_cookies->stream_type = $new_value;
                    $this->plugin->get_tv()->unload_channels();
                } else if ($control_id === 'show_vod')
                    $plugin_cookies->show_vod = $new_value;
                $need_reset_controls = true;

            }

        } else if ($user_input->action_type === 'close_window'){
            hd_print("SAVE PARAMS ".$this->session->get_parental_code()." == ".$user_input->pin1);
            // save params
            if ($this->session->get_parental_code() === $user_input->pin1){
                if (!empty($user_input->pin2)){
                    if ($this->session->set_parental_code($user_input->pin2)){

                        $this->plugin->get_tv()->unload_channels();

                        $plugin_cookies->need_password_sextv = $user_input->password_for_sextv;
                        $plugin_cookies->need_password_tariff = $user_input->password_for_tariff;
                        return ActionFactory::show_error(false,'Результат:',array('Данные сохранены успешно!'));
                    }else{
                        return ActionFactory::show_error(false,'Ошибка!',array('Данные не сохранены!'));
                    }
                }else{

                    $this->plugin->get_tv()->unload_channels();

                    $plugin_cookies->need_password_sextv = $user_input->password_for_sextv;
                    $plugin_cookies->need_password_tariff = $user_input->password_for_tariff;
                    return ActionFactory::show_error(false,'Результат:',array('Данные сохранены успешно!'));
                }
            }else{
//                $defs = array();
//                ControlFactory::add_label($defs, 'Указан неверный "старый пароль"!', '');
//                ControlFactory::add_close_dialog_button($defs, 'ОК', 300);
//                return ActionFactory::show_dialog("Ошибка!", $defs, true);
                return ActionFactory::show_error(false,'Ошибка!',array('Указан неверный "Текущий пароль"!'));
            }


        }

        if ($need_reset_controls)
        {



            $defs = $this->do_get_control_defs($plugin_cookies);

            $reset_controls_action = ActionFactory::reset_controls(
                $defs, $post_action);

            if ($need_close_dialog)
            {
                return ActionFactory::close_dialog_and_run(
                    $reset_controls_action);
            }

            return $reset_controls_action;
        }
    }
}

///////////////////////////////////////////////////////////////////////////
?>
