<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';
require_once 'lib/tv/tv_group_list_screen.php';

///////////////////////////////////////////////////////////////////////////

class I24hTopScreen extends AbstractPreloadedRegularScreen
{
    const ID = 'top_list';
    private $amedia;
    private $vod;
    private $session;
    
    private $cached_movies;

    ///////////////////////////////////////////////////////////////////////


    ///////////////////////////////////////////////////////////////////////

    public function __construct($session, $amedia, $vod)
    {
    	$this->session = $session;
        $this->amedia = $amedia;
        $this->vod = $vod;
        $this->cached_movies = array();
        
    	parent::__construct(
            self::ID,
            array
            (
                array
                (
                    PluginRegularFolderView::async_icon_loading => true,

                    PluginRegularFolderView::view_params => array
                    (
                        ViewParams::num_cols => 5,
                        ViewParams::num_rows => 4,
                        ViewParams::paint_details => false,
                        ViewParams::paint_sandwich => true,
                        ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                        ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                        ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                        ViewParams::sandwich_width => 320,//395,
                        ViewParams::sandwich_height => 168,//220,
                        ViewParams::sandwich_icon_upscale_enabled => true,
                        ViewParams::sandwich_icon_keep_aspect_ratio => false,
                        ViewParams::background_path => I24hConfig::BG_PIC,
                        ViewParams::background_width => 1920,
                        ViewParams::background_height => 1080,
                        ViewParams::background_order => 'before_all'

                    ),

                    PluginRegularFolderView::base_view_item_params => array
                    (
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::item_layout => HALIGN_CENTER,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1000,//1550,
                        ViewItemParams::icon_width => 320,//395,
#                        ViewItemParams::icon_height => 185,
                        ViewItemParams::icon_height => 168,//220,
                        ViewItemParams::item_paint_caption => false,
                    	ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
                    	ViewItemParams::item_detailed_icon_path => 'missing://',

                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array (),
                )
            ));

    }

    ///////////////////////////////////////////////////////////////////////
    public function get_handler_id()
    { return self::ID; }

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
  /*      $tv_favorite_action =
            UserInputHandlerRegistry::create_action(
                $this, 'add_tv_favorite');
        $tv_favorite_action['caption'] = 'Избранное ТВ';

        $video_favorite_action =
            UserInputHandlerRegistry::create_action(
                $this, 'add_video_favorite');
        $video_favorite_action['caption'] = 'Избранное видео';

        $video2_favorite_action =
            UserInputHandlerRegistry::create_action(
                $this, 'add_video2_favorite');
        $video2_favorite_action['caption'] = 'Избранное видео2';

*/
        return array(
        GUI_EVENT_KEY_ENTER => ActionFactory::open_folder(),
//        GUI_EVENT_KEY_A_RED => $tv_favorite_action,
//        GUI_EVENT_KEY_B_GREEN => $video_favorite_action,
//        GUI_EVENT_KEY_C_YELLOW => $video2_favorite_action,
        ); }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
        $items = array();
        

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
            MediaURL::encode(
            	array (
            	    'screen_id'   => TvGroupListScreen::ID
            	    )),
            PluginRegularFolderItem::caption => 'Каналы',
            PluginRegularFolderItem::view_item_params => array (
            	ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/Live.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Live.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/1.png'
            	)
            );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hAmediaListScreen::SCREEN_ID
                    )),
            PluginRegularFolderItem::caption => 'Амедиатека',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/Amediateka.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Amediateka.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/4.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hCtprimeraListScreen::SCREEN_ID
                    )),
            PluginRegularFolderItem::caption => 'ЦТ Премьера',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/CTprimeta.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Amediateka.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/4.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url => VodSearchScreen::get_media_url_str(),
            PluginRegularFolderItem::caption => 'Поиск',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/Search.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Search.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/3.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   =>  I24hSetupScreen::ID   //I24hPrivateScreen::ID
                    )),
            PluginRegularFolderItem::caption => 'Личный кабинет',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/Profile.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Profile.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/4.png'
            )
        );


        /*        $items[] = array
                (
                    PluginRegularFolderItem::media_url =>
                    MediaURL::encode(
                        array (
                            'screen_id'   => I24hTopcatListScreen::ID//I24hArchCatScreen::ID//I24hTopcatListScreen::ID
                            )),
                    PluginRegularFolderItem::caption => 'Архив',
                    PluginRegularFolderItem::view_item_params => array (
                        ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/Archive.jpg'//'http://iptv.home-ix.ru/iptv/icons/Main/Archive.jpg'
        #            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/2.png'
                        )
                    );
        */
        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hTopcatListScreen::ID,
                        'xcat_id'    => 1,
                    )),
            PluginRegularFolderItem::caption => 'Фильмы',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/ArchiveFilm.png'//'http://iptv.home-ix.ru/iptv/icons/Main/Live.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/1.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hTopcatListScreen::ID,
                        'xcat_id'    => 2,
                    )),
            PluginRegularFolderItem::caption => 'Сериалы',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/ArchiveSerials.png'//'http://iptv.home-ix.ru/iptv/icons/Main/Archive.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/2.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>  MediaURL::encode(
                array (
                    'screen_id'   => I24hTopcatListScreen::ID,
                    'xcat_id'    => 3,
                )),
            PluginRegularFolderItem::caption => 'Детям',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/ArchiveBaby.png'//'http://iptv.home-ix.ru/iptv/icons/Main/Search.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/3.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hTopcatListScreen::ID,
                        'xcat_id'    => 4,
                    )),
            PluginRegularFolderItem::caption => 'Передачи',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/ArchivePeredachi.png'//'http://iptv.home-ix.ru/iptv/icons/Main/Profile.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/4.png'
            )
        );

        $items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array (
                        'screen_id'   => I24hTopcatListScreen::ID,
                        'xcat_id'    => 5,
                    )),
            PluginRegularFolderItem::caption => 'Спорт',
            PluginRegularFolderItem::view_item_params => array (
                ViewItemParams::icon_path => 'http://static.24h.tv/dune/main/ArchiveSport.png'//'http://iptv.home-ix.ru/iptv/icons/Main/Amediateka.jpg'
#            	ViewItemParams::icon_path => 'http://24h.tv/tv/test/4.png'
            )
        );



        $atop = $this->amedia->make_top_list(5);
        
        $itemshist = array();

        hd_print('!!!!!!prodhist',print_r($plugin_cookies,true));

        if (isset($plugin_cookies->prodhist)) {
    		$prodhist = json_decode($plugin_cookies->prodhist, true);
    		$n = 0;
    		foreach ($prodhist as $prod) {
    		    if ($n>=5) break;

    		    //hd_print("prod['serial_id'] = ".$prod['serial_id']." , prod['type'] = ".$prod['type']);
                if (empty($prod['type'])) continue;
    			if ($prod['type'] == 1) {

                    if (empty($prod['product_id'])) continue;

    				$movie = $this->load_movie($prod['product_id']);

    				//hd_print(print_r($movie,true));
                    if ($movie['id'] == 0) continue;

                    hd_print('ICON PATH '.$movie['poster']);

    				$vip = array ( ViewItemParams::icon_path => $movie['poster'] );
    				    				
    				//hd_print(">>> <$movie->id> ".VodMovieScreen::get_media_url_str($media_url, $movie->id));

                   // hd_print(">>> movie_name: ".$movie['name']);

    				$itemshist[] = array
    				(
    					PluginRegularFolderItem::media_url =>
    						VodMovieScreen::get_media_url_str($movie['id']), // XXX: alik: hack!!
    					PluginRegularFolderItem::caption => $movie['name'],
    					PluginRegularFolderItem::view_item_params => $vip,
    					);
    			}
    			if ($prod['type'] == 2) {
                    if (empty($prod['serial_id'])) continue;
    				$itemshist[] = $this->amedia->make_single_item($prod['serial_id']);
    			}
    			$n++;

    		}
    	}
#        hd_print("****************************************************");
#        hd_print("****************************************************");
#    	hd_print("****************************************************");
#        hd_print(print_r(array_merge($itemshist),true));
#        hd_print("****************************************************");
#        hd_print("****************************************************");
#        hd_print("****************************************************");

        return array_merge($items, $atop, $itemshist);
    }
    
    private function load_movie($movie_id) 
    {

       // hd_print("function LOAD MOVIE");
    	$this->session->ensure_logged_in($plugin_cookies);
    	
    	if (isset($this->cached_movies[$movie_id])) {
    		return $this->cached_movies[$movie_id];
    	}
    	
        $doc =
            HD::http_get_document(
                sprintf(
                    $this->session->get_api_server() . I24hConfig::MOVIE_INFO_URL_FORMAT,
                    $movie_id, $this->session->get_token()));
     
        if (is_null($doc))
            throw new Exception('Can not fetch movie info');
        hd_print("XML-text:\n$doc\n");
        $xml = simplexml_load_string($doc);

        if ($xml === false)
        {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text:\n$doc\n");
            throw new Exception('Illegal XML document');
        }

        if ($xml->getName() !== 'root')
        {
            hd_print("Error: unexpected node '" . $xml->getName() .
                "'. Expected: 'movie_info'");
            throw new Exception('Invalid XML document');
        }

       // hd_print("xml: ".print_r($xml,true));
        $poster = "";
        $frame = "";
        if (!empty($xml->img)) {

            foreach ($xml->img->children() as $s) {
                if (strval($s->type) == "poster") {
                    $poster = strval($s->src);
                    break;
                }
            }

            foreach ($xml->img->children() as $s) {
                if (strval($s->type) == "frame") {
                    $frame = strval($s->src);
                    break;
                }
            }
        }
        $movie = array(
        	'id' => intval($xml->id),
        	'name' =>  strval($xml->title),
        	'poster' =>  !empty($poster)?$poster:$frame."?w=320&h=200&crop=true"); // preg_replace('/\/res\//', "/resize/320x200/res/", strval($xml->img->file->url)));
        
        $this->cached_movies[$movie_id] = $movie;
        return $movie;
    	
    }

}

///////////////////////////////////////////////////////////////////////////
?>

