<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';
require_once 'lib/vod/abstract_vod.php';
require_once 'lib/vod/movie.php';

///////////////////////////////////////////////////////////////////////////

class I24hVideoListScreen extends AbstractRegularScreen /*AbstractPreloadedRegularScreen*/ implements UserInputHandler
{

    public static function get_media_url_str($category_id, $id)
    {
        return MediaURL::encode(
            array
            (
                'screen_id' => $id,
                'category_id' => $category_id,
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    private $topcats;
    private $subcats;
    private $session;

    private $serials;
    private $genres;
    private $movies;
    private $toplist;

    private $id;
    private $filter_id;
    private $source_id;
    private $name;
    private $allow_view;
    private $allow_in_packets = array();
    private $lazy_limit = 20;
    private $is_need_label = false;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($session, $screen_id, $filter_id, $source_id, $name, $is_need_label = false)
    {
        parent::__construct(
            $screen_id,
            array
            ());
        $this->session = $session;

        $subcats = array();
        $this->serials = array();
        $this->movides = array();
        $this->filter_id = $filter_id;
        $this->id = $screen_id;
        //$his->screen_id=$screen_id;
        $this->source_id = $source_id;
        $this->name = $name;
        $this->is_need_label = $is_need_label;

        UserInputHandlerRegistry::get_instance()->register_handler($this);

    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        hd_print("run function get_action_map");
        if (isset($media_url->serieslist_id)) {

            $play_action =
                UserInputHandlerRegistry::create_action(
                    $this, 'play_video');


            return array
            (
                GUI_EVENT_KEY_ENTER => $play_action,//ActionFactory::show_error(false,'Hello enter '.$this->source_id),//ActionFactory::vod_play(),
                GUI_EVENT_KEY_PLAY => $play_action//ActionFactory::show_error(false,'Hello play  '.$this->source_id),//ActionFactory::vod_play(),
            );
        } else {
            return array(GUI_EVENT_KEY_ENTER => ActionFactory::open_folder());
        }
    }


    public function get_handler_id(){
        return $this->id;
    }

    ///////////////////////////////////////////////////////////////////////

    public function is_user_subcribers()
    {

//        hd_print("is_user_subcribers!");

        $this->allow_view = false;
        $cur_video = $this->session->get_current_videos();

//        hd_print("CURRENT VIDEO: ".print_r($cur_video,true));

        if ($cur_video[$this->source_id]) $this->allow_view = true;

        if (!$this->allow_view) {
            $pc=$this->session->get_videos_in_packets();
            unset($this->allow_in_packets);
            $this->allow_in_packets = $pc[$this->source_id];
        }
    }



    public function get_folder_range(MediaURL $media_url, $from_ndx,&$plugin_cookies)
    {
        hd_print("get_folder_range " . $from_ndx);



        hd_print("mediaURL ".print_r($media_url,true));

        $this->session->ensure_logged_in($plugin_cookies);
        $count_video = 0;

        $items = array();

        //$server_id = 0;
        //$CFG_MEDIA_SERVERS		    = array('media.centr.lan','media.sever.ru');

        if (isset($media_url->xcat_id)) {
            $subcats = $this->fetch_subcat_list($media_url->xcat_id,$from_ndx,$this->lazy_limit);
            foreach ($subcats as $m) {
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => I24hVodListScreen::get_media_url_str($m['id'], $this->id),
                    PluginRegularFolderItem::caption => $m['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai'
                    )
                );
            }

        } else if (isset($media_url->serieslist_id)) {
            hd_print(" get_all_folder_items: find serieslist_id !!!!!!!!!!!!!!!!!!!!");
            //    $this->is_user_subcribers();
            $serial = $this->fetch_serial($media_url->serial_id);
            $season = $serial['seasons'][$media_url->serieslist_id];
            //$series = $this->fetch_series_list($media_url->serieslist_id);
            $movie = $this->get_loaded_series($media_url->serial_id, $media_url->serieslist_id, $plugin_cookies,$from_ndx,$this->lazy_limit);

            $i = 0;
            foreach ($movie->series_list as $s) {
                $s_mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,//self::ID,//I24hAmediaListScreen::ID,
                        'serial_id' => $media_url->serial_id,
                        'serieslist_id' => $media_url->serieslist_id,
                        'serie_id' => $s->id
                    ));
                $i++;
                $img = $this->is_need_label?($s->icon . "&video_label=true&id=" . $media_url->serial_id):($s->icon . "&crop=true");
                hd_print("SER_IMG: ".$img);
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $s_mediaurl, //$s->playback_url,
                    PluginRegularFolderItem::caption => $s->name,
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $img,  //$this->serials[$media_url->serial_id]['img']
                    )
                );
                $count_video++;
            }
        } else if ((isset($media_url->serial_id)) && (isset($media_url->season_id))) {


        } else if (isset($media_url->serial_id)) {
            hd_print("1  >> " . $media_url->serial_id);


            $serial = $this->fetch_serial($media_url->serial_id);

            $serial_desc = $serial['name'] . ", " . $serial['year'] . "\n" .
                (!empty($serial['original']) ? "(" . $serial['original'] . ")\n" : "") . "\n" .
                "Рейтинги:\n" .
                'IMDB: ' . (!empty($serial['rating_imdb']) ? $serial['rating_imdb'] : "-") . "\n" .
                'Кинопоиск: ' . (!empty($serial['kinopoisk']) ? $serial['kinopoisk'] : "-") . "\n" .
                'MPAA: ' . (!empty($serial['age']) ? $serial['age'] . "+" : "");

            $sesons = $serial['seasons'];
            $seson = reset($sesons);
            $arr = preg_split("/;/", $seson['id']);

            if ($arr[1] > 0) {
                foreach ($serial['seasons'] as $s) {

                    $arr = preg_split("/;/", $s['id']);

                    hd_print("2  >> " . $s['id']);
                    hd_print("seson N " . $arr[1]);


                    $mediaurl = MediaURL::encode(
                        array(
                            'screen_id' => $this->id,
                            'serial_id' => $media_url->serial_id,
                            'serieslist_id' => $s['id']
                        ));


                    $img = $serial['img'].($this->is_need_label?"?w=320&h=200&video_label=true&id=".$serial["id"]:"?w=320&h=200&crop=true");

                    $items[] = array
                    (
                        PluginRegularFolderItem::media_url => $mediaurl,
                        PluginRegularFolderItem::caption => $s['name'],
                        PluginRegularFolderItem::view_item_params => array(
                            ViewItemParams::item_detailed_icon_path => $img,
                            ViewItemParams::item_detailed_info => $serial_desc,

                        )
                    );
                    $count_video++;

//                    hd_print("SER IMG: ".$img);

                }
            } else {
                hd_print("One series");

                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'serial_id' => $media_url->serial_id,
                        'serieslist_id' => $media_url->serial_id . ";0"
                    ));

                $serial = $this->fetch_serial($media_url->serial_id);
                $season = $serial['seasons'][$media_url->serial_id . ";0"];

                hd_print("get_all_folder_items fetch_series_list");
                $series = $this->fetch_series_list($media_url->serial_id . ";0",$from_ndx,$this->lazy_limit);
                $movie = $this->get_loaded_series($media_url->serial_id, $media_url->serial_id . ";0", $plugin_cookies,$from_ndx,$this->lazy_limit);

                $i = 0;
                foreach ($movie->series_list as $s) {
                    $s_mediaurl = MediaURL::encode(
                        array(
                            'screen_id' => $this->id,
                            'serial_id' => $media_url->serial_id,
                            'serieslist_id' => $media_url->serial_id . ";0",
                            'serie_id' => $s->id
                        ));
                    $i++;



                    $items[] = array
                    (
                        PluginRegularFolderItem::media_url => $s_mediaurl,
                        PluginRegularFolderItem::caption => $s->name,
                        PluginRegularFolderItem::view_item_params => array(
                            ViewItemParams::icon_path => $s->icon,
                        )
                    );
                }


            }

        } else if (isset($media_url->genre_id)) {

            hd_print("isset media_url->genre_id " . $media_url->genre_id);

            $this->fetch_topmovie_list($media_url->genre_id,$from_ndx,$this->lazy_limit);
            //$this->fetch_genre_list();
            foreach ($this->genres[$media_url->genre_id]['serials'] as $s) {
                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'serial_id' => $s['id']
                    ));
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $mediaurl,
                    PluginRegularFolderItem::caption => $s['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $s['img'].($this->is_need_label?'&video_label=true&id='.$s['id']:'&crop=true')
                    )
                );

//                hd_print('IMG: '.$s['img'].($this->is_need_label?'&video_label=true&id='.$s['id']:''));
                $count_video++;

            }
        } else {
            hd_print("ELSE!!!!!!!!!!");
            $this->fetch_genre_list();
            foreach ($this->genres as $g) {

                hd_print("genres name: " . $g['name'] . " img: " . $g['img']);

                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'genre_id' => $g['id']
                    ));
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $mediaurl,
                    PluginRegularFolderItem::caption => $g['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $g['img']
                    )
                );
            }
            return HD::create_regular_folder_range(
                $items, 0, count($items),false);

        }
        hd_print("RETURN MEDIA URL");
        //return $items;







        $more = false;
        if ($count_video >= $this->lazy_limit){$more = true;}else{hd_print("End");}

        hd_print("from = ".$from_ndx.", total = ".($from_ndx+$this->lazy_limit).", count = ".$count_video);

        return HD::create_regular_folder_range(
            $items, $from_ndx, $from_ndx+$count_video,$more);


    }


    public function get_all_folder_items_old(MediaURL $media_url, &$plugin_cookies)
    {
        //	hd_print("******************* MEDIA URL **********************");
        //	hd_print(print_r($media_url,true));
        //    hd_print("****************************************************");

        hd_print("run function get_all_folder_items");
        hd_print("mediaURL ".print_r($media_url,true));

        $this->session->ensure_logged_in($plugin_cookies);


        $items = array();

        //$server_id = 0;
        //$CFG_MEDIA_SERVERS		    = array('media.centr.lan','media.sever.ru');

        if (isset($media_url->xcat_id)) {
            $subcats = $this->fetch_subcat_list($media_url->xcat_id);
            foreach ($subcats as $m) {
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => I24hVodListScreen::get_media_url_str($m['id'], $this->id),
                    PluginRegularFolderItem::caption => $m['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai'
                    )
                );
            }

        } else if (isset($media_url->serieslist_id)) {
            hd_print(" get_all_folder_items: find serieslist_id !!!!!!!!!!!!!!!!!!!!");
        //    $this->is_user_subcribers();
            $serial = $this->fetch_serial($media_url->serial_id);
            $season = $serial['seasons'][$media_url->serieslist_id];
            //$series = $this->fetch_series_list($media_url->serieslist_id);
            $movie = $this->get_loaded_series($media_url->serial_id, $media_url->serieslist_id, $plugin_cookies);

            $i = 0;
            foreach ($movie->series_list as $s) {
                $s_mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,//self::ID,//I24hAmediaListScreen::ID,
                        'serial_id' => $media_url->serial_id,
                        'serieslist_id' => $media_url->serieslist_id,
                        'serie_id' => $s->id
                    ));
                $i++;
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $s_mediaurl, //$s->playback_url,
                    PluginRegularFolderItem::caption => $s->name,
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $s->icon, //$this->serials[$media_url->serial_id]['img']
                    )
                );
            }
        } else if ((isset($media_url->serial_id)) && (isset($media_url->season_id))) {


        } else if (isset($media_url->serial_id)) {
            hd_print("1  >> " . $media_url->serial_id);


            $serial = $this->fetch_serial($media_url->serial_id);

            $serial_desc = $serial['name'] . ", " . $serial['year'] . "\n" .
                (!empty($serial['original']) ? "(" . $serial['original'] . ")\n" : "") . "\n" .
                "Рейтинги:\n" .
                'IMDB: ' . (!empty($serial['rating_imdb']) ? $serial['rating_imdb'] : "-") . "\n" .
                'Кинопоиск: ' . (!empty($serial['kinopoisk']) ? $serial['kinopoisk'] : "-") . "\n" .
                'MPAA: ' . (!empty($serial['age']) ? $serial['age'] . "+" : "");

            $sesons = $serial['seasons'];
            $seson = reset($sesons);
            $arr = preg_split("/;/", $seson['id']);

            if ($arr[1] > 0) {
                foreach ($serial['seasons'] as $s) {

                    $arr = preg_split("/;/", $s['id']);

                    hd_print("2  >> " . $s['id']);
                    hd_print("seson N " . $arr[1]);


                    $mediaurl = MediaURL::encode(
                        array(
                            'screen_id' => $this->id,
                            'serial_id' => $media_url->serial_id,
                            'serieslist_id' => $s['id']
                        ));
                    $items[] = array
                    (
                        PluginRegularFolderItem::media_url => $mediaurl,
                        PluginRegularFolderItem::caption => $s['name'],
                        PluginRegularFolderItem::view_item_params => array(
                            ViewItemParams::item_detailed_icon_path => $serial['img'],
                            ViewItemParams::item_detailed_info => $serial_desc,

                        )
                    );

                }
            } else {
                hd_print("One series");

                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'serial_id' => $media_url->serial_id,
                        'serieslist_id' => $media_url->serial_id . ";0"
                    ));

                $serial = $this->fetch_serial($media_url->serial_id);
                $season = $serial['seasons'][$media_url->serial_id . ";0"];

                hd_print("get_all_folder_items fetch_series_list");
                $series = $this->fetch_series_list($media_url->serial_id . ";0");
                $movie = $this->get_loaded_series($media_url->serial_id, $media_url->serial_id . ";0", $plugin_cookies);

                $i = 0;
                foreach ($movie->series_list as $s) {
                    $s_mediaurl = MediaURL::encode(
                        array(
                            'screen_id' => $this->id,
                            'serial_id' => $media_url->serial_id,
                            'serieslist_id' => $media_url->serial_id . ";0",
                            'serie_id' => $s->id
                        ));
                    $i++;
                    $items[] = array
                    (
                        PluginRegularFolderItem::media_url => $s_mediaurl,
                        PluginRegularFolderItem::caption => $s->name,
                        PluginRegularFolderItem::view_item_params => array(
                            ViewItemParams::icon_path => $s->icon,
                        )
                    );
                }


            }

        } else if (isset($media_url->genre_id)) {



            hd_print("isset media_url->genre_id " . $media_url->genre_id);

            $this->fetch_topmovie_list($media_url->genre_id);
            $this->fetch_genre_list();
            foreach ($this->genres[$media_url->genre_id]['serials'] as $s) {
                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'serial_id' => $s['id']
                    ));
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $mediaurl,
                    PluginRegularFolderItem::caption => $s['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $s['img']
                    )
                );

            }
        } else {
            hd_print("ELSE!!!!!!!!!!");
            $this->fetch_genre_list();
            foreach ($this->genres as $g) {

                hd_print("genres name: " . $g['name'] . " img: " . $g['img']);

                $mediaurl = MediaURL::encode(
                    array(
                        'screen_id' => $this->id,
                        'genre_id' => $g['id']
                    ));
                $items[] = array
                (
                    PluginRegularFolderItem::media_url => $mediaurl,
                    PluginRegularFolderItem::caption => $g['name'],
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::icon_path => $g['img']
                    )
                );

            }

        }
        hd_print("RETURN MEDIA URL");
        return $items;
    }



    public function make_top_list($count)
    {
        hd_print("run function make_top_list");

        $items = array();

        $this->fetch_genre_list();
        $this->fetch_topmovie_list(null);
        $i = 1;
        foreach ($this->toplist as $s_id) {
            $s = $this->serials[$s_id];

            $mediaurl = MediaURL::encode(
                array(
                    'screen_id' => $this->id,//self::ID,//I24hAmediaListScreen::ID,
                    'serial_id' => $s['id']
                ));

            hd_print("AMEDIA ICON PATH ".$s['img']);

            $items[] = array
            (
                PluginRegularFolderItem::media_url => $mediaurl,
                PluginRegularFolderItem::caption => $s['name'],
                PluginRegularFolderItem::view_item_params => array(
                    ViewItemParams::icon_path => strval($s['img'])
                )
            );
            $i++;
            if ($i > $count) {
                break;
            }

        }
        return $items;
    }

    public function make_single_item($serial_id)
    {
        hd_print("run function make_single_item");

        $this->fetch_genre_list();
        $s = $this->fetch_serial($serial_id);

        //hd_print(print_r($s,true));

        $mediaurl = MediaURL::encode(
            array(
                'screen_id' => $this->id,//self::ID,//I24hAmediaListScreen::ID,
                'serial_id' => $s['id']
            ));


     //   hd_print("make_single_item icon_path: ".$s['img']);
        if ($s["source_id"]==1) {
            $img = strval($s['img'])."?w=320&h=200&video_label=true&id=".strval($s['id']);
            hd_print($s['name']."\nNeed VIDEO LABEL  ".$img);
        }else{
            $img = strval($s['img'])."?w=320&h=200&crop=true";
            hd_print($s['name']."\nNO VIDEO LABEL  ".$img);
        }

        return array
        (
            PluginRegularFolderItem::media_url => $mediaurl,
            PluginRegularFolderItem::caption => $s['name'],
            PluginRegularFolderItem::view_item_params => array(
                ViewItemParams::icon_path => $img
            )
        );
    }


    private function fetch_topmovie_list($genre_id,$from_ndx = 0,$lazy_limit = 0)
    {
        hd_print("run function fetch_topmovie_list");
        hd_print('2');
        /*    	if (!$genre_id) {
                    $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_TOP_LIST, $this->session->get_token()));
                    $this->toplist = array();
                } else {
                    // TODO Add Limit and offset
                    $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_SERIALS_LIST, $this->session->get_token(), $genre_id));
                }

                if (is_null($doc))
                    throw new Exception('Can not fetch topmovie list');
                $xml = simplexml_load_string($doc);

                if ($xml === false)
                {
                    hd_print("Error: can not parse XML document.");
                    hd_print("XML-text: $doc.");
                    throw new Exception('Illegal XML document');
                }

                if ($xml->getName() !== 'root')
                {
                    hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
                    throw new Exception('Invalid XML document');
                }

        */
        if (!$genre_id) {


            $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_TOP_LIST, $this->session->get_token()));

            $this->toplist = array();
            if (is_null($doc))
                throw new Exception('Can not fetch topmovie list');
            $xml = simplexml_load_string($doc);

            if ($xml === false) {
                hd_print("Error: can not parse XML document.");
                hd_print("XML-text: $doc.");
                throw new Exception('Illegal XML document');
            }

            if ($xml->getName() !== 'root') {
                hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
                throw new Exception('Invalid XML document');
            }

            // TODO Промоушен тут надо по Амедиатеке
            foreach ($xml->children() as $c) {

                hd_print("Promotions banner - " . $c->banner);
                $banner = $c->banner . "?w=320&h=200";
                $doc2 = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_TOP_SERIAL_INFO, $c->destination->id, $this->session->get_token()));
                if (is_null($doc2))
                    throw new Exception('Can not fetch topmovie list');
                $xml2 = simplexml_load_string($doc2);

                if ($xml2 === false) {
                    hd_print("Error: can not parse XML document.");
                    hd_print("XML-text: $doc2.");
                    throw new Exception('Illegal XML document');
                }

                if ($xml2->getName() !== 'root') {
                    hd_print("Error: unexpected node '" . $xml2->getName() . "'. Expected: 'response'");
                    throw new Exception('Invalid XML document');
                }


                $poster = "";
                foreach ($xml2->img->children() as $i) {
                    $poster = strval($i->src) . "?w=320&h=200";
                }

                hd_print("---------------------------");
                hd_print("source = " . $xml2->source->id . " xml2->title " . $xml2->title . " scr = " . $poster);

                //if ($xml2->source->id==1){
                if (1 == 1) {
                    $this->serials[strval($xml2->id)] = array(
                        'id' => strval($xml2->id),
                        'name' => strval($xml2->title),
                        'year' => strval($xml2->year),
                        'descr' => strval($xml2->description),
                        'img' => $banner,//$poster,//preg_replace('/\/res\//', "/resize/320x200/res/", strval($c->img16x9->url)),
                        'seasons' => array()
                    );
                    $serial_id = $xml2->id;
                    $seasons = array();
                    foreach ($xml2->episodes->children() as $s) {
                        $seasons[$serial_id . ";" . $s->season] = $xml2->title;
                    }
                    foreach ($seasons as $k => $v) {
                        hd_print('  season_id: ' . strval($k) . ', name: ' . strval($v));
                        $chars = preg_split('/;/', strval($k));
                        $this->serials[strval($xml2->id)]['seasons'][strval($k)] = array(
                            'id' => strval($k),
                            'name' => "Сезон " . $chars[1],
                            'year' => '',
                            'descr' => '',
                        );
                    }
                    $this->toplist[] = strval($xml2->id);
                }
            }


            //$this->toplist[] = strval($c->id);


        } else {

            // TODO Add Limit and offset

            //,$from_ndx,$lazy_limit
            if (!isset($this->genres)) $this->fetch_genre_list();

            $this->genres[$genre_id]['serials'] = array();

                hd_print("Iteration offset = " . $from_ndx . " , limit = " . $lazy_limit);
                $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_SERIALS_LIST, $this->session->get_token(), $genre_id, $lazy_limit, $from_ndx));

                if (is_null($doc))
                    throw new Exception('Can not fetch topmovie list');
                $xml = simplexml_load_string($doc);

                if ($xml === false) {
                    hd_print("Error: can not parse XML document.");
                    hd_print("XML-text: $doc.");
                    throw new Exception('Illegal XML document');
                }

                if ($xml->getName() !== 'root') {
                    hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
                    throw new Exception('Invalid XML document');
                }

                //$this->topcats = array();
                $count_video = 0;
                foreach ($xml->children() as $c) {


                    if (!isset($this->serials[strval($c->id)])) {
                        hd_print('id: ' . strval($c->id) . ', name: ' . strval($c->title));

                        $poster = "";
                        foreach ($c->img->children() as $i) {
                            $poster = strval($i->src) . "?w=320&h=200";//&crop=true";
                        }

                        $this->serials[strval($c->id)] = array(
                            'id' => strval($c->id),
                            'name' => strval($c->title),
                            'year' => strval($c->year),
                            'original' => strval($c->original),
                            'rating_imdb' => strval($c->rating_imdb),
                            'rating_kinopoisk' => strval($c->rating_kinopoisk),
                            'age' => strval($c->age),
                            'descr' => strval($c->description),
                            'img' => $poster,//preg_replace('/\/res\//', "/resize/320x200/res/", strval($c->img16x9->url)),
                            'seasons' => array()
                        );
                        $serial_id = $c->id;
                        //$sl = $this->serials[strval($c->id)];
                        $seasons = array();
                        /*                        foreach ($c->episodes->children() as $s) {
                                                    $seasons[$serial_id . ";" . $s->season] = $c->title;
                                                }
                                                foreach ($seasons as $k => $v) {
                                                    hd_print('  season_id: ' . strval($k) . ', name: ' . strval($v));
                                                    $chars = preg_split('/;/', strval($k));

                                                    $this->serials[strval($c->id)]['seasons'][strval($k)] = array(
                                                        'id' => strval($k),
                                                        'name' => "Сезон " . $chars[1],
                                                        'year' => '',
                                                        'descr' => '',
                                                    );
                                                }
                        */

//                        $this->serials[strval($c->id)]['seasons'][strval($s->id)] = array(
//                            'id' => strval($s->id),
//                            'name' => strval($s->name),
//                            'year' => strval($s->year),
//                            'descr' => strval($s->description)
//                        );
                        //                  }
                    }
                    $this->genres[$genre_id]['serials'][] = $this->serials[strval($c->id)];
//                    $count_video++;

                }

//                if ($genre_id) {
//                    if (!isset($this->genres)) {
//                        $this->fetch_genre_list();
//                    }
//                } else {
                //$this->toplist[] = strval($c->id);
//                }
  //              $offset += $limit;
        }
    }



    private function fetch_genre_list()
    {
        hd_print("run function fetch_genre_list");
        hd_print("SOURCE ID = " . $this->source_id . " FILTER ID " . $this->filter_id . " genres_id = " . $this->genres);
        if (!isset($this->genres)) {
            $this->genres = array();

            hd_print("session token: " . $this->session->get_token());

            $headers = array();
            $headers[] = 'Accept: application/xml';
            $headers[] = 'Content-Type: application/xml';
            //$doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_GENRE_LIST, $this->session->get_token()));
            $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_GENRE_LIST, $this->session->get_token())/*,array(CURLOPT_HTTPHEADER=>$headers)*/);
            //hd_print("--------------------");
            //hd_print($doc);
            //hd_print("--------------------");

            if (is_null($doc))
                throw new Exception('Can not fetch topmovie list');
            $xml = simplexml_load_string($doc);


            hd_print("xml->getName() = " . $xml->getName());

            if ($xml === false) {
                hd_print("Error: can not parse XML document.");
                hd_print("XML-text: $doc.");
                throw new Exception('Illegal XML document');
            }

            if ($xml->getName() !== 'root') {
                hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'root'");
                throw new Exception('Invalid XML document');
            }

            $this->topcats = array();

            foreach ($xml->children() as $c) {

                hd_print("FILTER_ID = " . $this->filter_id);

                if ($c->id == $this->filter_id /*== 77*/) {
                    foreach ($c->filters->children() as $l) {

                        $img = I24hConfig::GET_VOD_GENRES_IMG($this->name . ' / ' . strval($l->name));
                       // hd_print("Load GET_VOD_GENRES_IMG [" . $this->name . ' / ' . strval($l->name) . "] : " . $img);

                        $this->genres[strval($l->id)] = array(
                            'id' => strval($l->id),
                            'name' => strval($l->name),
                            // TODO Тут надо хардкодить картинки
                            'img' => 'gui_skin://small_icons/folder.aai',//$img . '?w=320&h=200',//   '', //preg_replace('/\/res\//', "/resize/320x200/res/", strval($c->dune->url)),
                            'serials' => array()
                        );

                    }
                }
//				hd_print("children id=" .$c->id." name=".$c->name );
            }


            /*    	    foreach ($xml->children() as $c) {
                                //hd_print('id: '.strval($c->id).', name: '.strval($c->name));
                                $this->genres[strval($c->genre_id)] = array (
                                    'id' => strval($c->genre_id),
                                    'name' => strval($c->name),
                                    'img' => preg_replace('/\/res\//', "/resize/320x200/res/", strval($c->dune->url)),
                                    'serials' => array()
                                    );
                        }
            */
        }
    }


    private function fetch_series_list($season_id,$from_ndx,$lazy_limit)
    {

        hd_print("run function fetch_series_list");

        // TODO Если серия одна в сериале, то прыгием на список серий
        $series = array();

        hd_print("*********************  fetch_series_list $season_id *****************************");

        $serils_seasons = preg_split('/;/', strval($season_id));

        $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_SERIES_LIST,
            $serils_seasons[0], $this->session->get_token()));
        if (is_null($doc))
            throw new Exception('Can not fetch topmovie list');
        $xml = simplexml_load_string($doc);

        if ($xml === false) {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }

        if ($xml->getName() !== 'root') {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
            throw new Exception('Invalid XML document');
        }

        // Идем по VIDEO_SERIES_LIST, выбираем нужные эпизоды из сериала, далее берем url VIDEO_EPISODES_URL

        //$this->topcats = array();
        foreach ($xml->children() as $c) {
            if ($c->season == $serils_seasons[1]) {

                $eps = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_EPISODES_URL,
                    $serils_seasons[0], strval($c->id), 'hls'/*$plugin_cookies->stream_type*/, $this->session->get_token()));


                if (is_null($eps))
                    throw new Exception('Can not fetch topmovie list');
                $xml_eps = simplexml_load_string($eps);

                if ($xml_eps === false) {
                    hd_print("Error: can not parse XML document.");
                    hd_print("XML-text: $eps.");
                    throw new Exception('Illegal XML document');
                }

                if ($xml_eps->getName() !== 'root') {
                    hd_print("Error: unexpected node '" . $xml_eps->getName() . "'. Expected: 'response'");
                    throw new Exception('Invalid XML document');
                }

                //  foreach ($xml_eps->children() as $e) {
                $list_name = "";
                if (strval($c->series) == 0) {
                    $list_name = ltrim(strval($c->list_title), '0. ');
                } else {
                    $list_name = strval($c->list_title);
                }
                hd_print('id: ' . strval($c->id) . ', name: ' . strval($c->list_title) . ', img: ' . $c->img);
                $series[] = array(
                    'id' => strval($c->id),
                    'name' => strval($list_name),// (strval($c->series)) . '. ' . (strval($c->name)),
                    'url' => strval($xml_eps->hls),//strval($c->url),
                    'img' => strval($c->img) . "?w=320&h=200",//&crop=true",//preg_replace('/\/res\//', "/resize/320x200/res/", strval($c->img->url)),
                );
                //}
            }
        }
        return $series;
    }

    private function fetch_serial($serial_id)
    {

        hd_print("run function fetch_serial");
        hd_print("*********************  fetch_serial $serial_id *****************************");

        if (isset($this->serials[$serial_id])) {
            //	return $this->serials[$serial_id];
        }

        $series = array();

        $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_SERIAL, $serial_id, $this->session->get_token()));
        if (is_null($doc))
            throw new Exception('Can not fetch topmovie list');
        $xml = simplexml_load_string($doc);

        if ($xml === false) {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }

        if ($xml->getName() !== 'root') {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
            throw new Exception('Invalid XML document');
        }


        $poser = '';
        foreach ($xml->img->children() as $i) {
            if ($i->type == 'poster') {
                $poser = $i->src;
                break;
            }
        }

        hd_print('id: ' . strval($xml->id) . ', name: ' . strval($xml->title) . ' poser = ' . $poser);
        $this->serials[strval($xml->id)] = array(
            'id' => strval($xml->id),
            'name' => strval($xml->title),
            'original' => strval($xml->original),
            'rating_imdb' => strval($xml->rating_imdb),
            'rating_kinopoisk' => strval($xml->rating_kinopoisk),
            'source_id' => strval($xml->source->id),
            'age' => strval($xml->age),
            'year' => strval($xml->year),
            'descr' => strval($xml->description),
            'img' => $poser ,//. "?w=320&h=200",//&crop=true",//preg_replace('/\/res\//', "/resize/320x200/res/", strval($xml->img16x9->url)),
            'seasons' => array()
        );

        //$sl = $this->serials[strval($xml->id)];
        hd_print("Poser " . $poser);
        foreach ($xml->episodes->children() as $ep) {
            $seasons[strval($xml->id) . ";" . strval($ep->season)] = strval($ep->list_title);
        }
        // asort($seasons);
        foreach ($seasons as $k => $v) {
            $arr = preg_split("/;/", $k);
            hd_print('####  season_id: ' . strval($k) . ', name: ' . strval($v) . ", seson № " . $arr[1] . ".");

            if ($arr[1] > 0) {
                $this->serials[strval($xml->id)]['seasons'][strval($k)] = array(
                    'id' => strval($k),
                    'name' => 'Сезон ' . $arr[1],//.". ".strval($v),
                    'year' => strval($xml->year),
                    'descr' => strval($xml->description),
                    'img' => $poser ,//. "?w=320&h=200",//&crop=true",//preg_replace('/\/res\//', "/resize/320x200/res/", strval($xml->img16x9->url)),

                );
            } else {
                $this->serials[strval($xml->id)]['seasons'][strval($k)] = array(
                    'id' => strval($k),
                    'name' => strval($xml->title),
                    'year' => strval($xml->year),
                    'descr' => strval($xml->description),
                    'img' => $poser ,//. "?w=320&h=200",//&crop=true",//preg_replace('/\/res\//', "/resize/320x200/res/", strval($xml->img16x9->url)),

                );

            }
        }

        /*  	foreach ($xml->vodSeasons->children() as $s) {
                  hd_print('  season_id: '.strval($s->id).', name: '.strval($xml->name));
                  $this->serials[strval($xml->id)]['seasons'][strval($s->id)] = array (
                      'id' => strval($s->id),
                      'name' => strval($s->name),
                      'year' => strval($s->year),
                      'descr' => strval($s->description)
                      );
              }
              */
        return $this->serials[strval($xml->id)];

    }

    private function fetch_topcat_list()
    {
        /*$doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::TOPCAT_LIST_URL, $this->session->get_token()));
        if (is_null($doc))
                throw new Exception('Can not fetch topcat list');
        $xml = simplexml_load_string($doc);

        if ($xml === false)
        {
                hd_print("Error: can not parse XML document.");
                hd_print("XML-text: $doc.");
                throw new Exception('Illegal XML document');
        }

        if ($xml->getName() !== 'response')
        {
                hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
                throw new Exception('Invalid XML document');
        }

        $this->topcats = array();
        foreach ($xml->children() as $c) {
                $this->topcats[] = array (
                                 'id' => strval($c->id),
                                 'name' => strval($c->name),
                                 'img' => strval($c->img->url)
                                 );

        }
        */

        /* 	    $this->topcats = array();
                 $this->topcats[] = array('id' => 1, 'name' => 'Фильмы', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Amediateka/Movies.png');
                 $this->topcats[] = array('id' => 2, 'name' => 'Сериалы', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Amediateka/Series.png');
                 $this->topcats[] = array('id' => 3, 'name' => 'Шоу', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Amediateka/Show.png');
                 $this->topcats[] = array('id' => 4, 'name' => 'Поиск', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Amediateka/Search.png');

                 $this->topcats[] = array('id' => 5, 'name' => "Метод\nСерия 16 Сезон 1", 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/method.jpg');
                 $this->topcats[] = array('id' => 6, 'name' => 'Игра престолов', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/igra_prestolov.jpg');
                 $this->topcats[] = array('id' => 7, 'name' => 'Агенты Щ.И.Т.', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/schit.jpg');
                 $this->topcats[] = array('id' => 8, 'name' => 'Как это делается в Америке', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/kak_eto_delaetsa.jpg');

                 $this->topcats[] = array('id' => 9, 'name' => "Черные паруса", 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/chernie_parusa.jpg');
                 $this->topcats[] = array('id' => 10, 'name' => 'Девочки', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/girls.jpg');
                 $this->topcats[] = array('id' => 11, 'name' => 'Родина', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/rodina.jpg');
                 $this->topcats[] = array('id' => 12, 'name' => 'Эмми', 'img' => 'http://iptv.home-ix.ru/iptv/icons/Demo/emmy_43_320x260c.jpg');
         */
    }

    private function fetch_subcat_list($subcat_id)
    {

        $subcats = array();

        hd_print("fetch_subcat_list >> $subcat_id");

        if ($subcat_id == 1) {
            $subcats[] = array('id' => '20|25', 'name' => 'Все');
            $subcats[] = array('id' => '20|25', 'name' => 'Драмы');
            $subcats[] = array('id' => '20|30', 'name' => 'Фэнтези');
            $subcats[] = array('id' => '20|15', 'name' => 'Мелодрамы');
            $subcats[] = array('id' => '20|38', 'name' => 'Исторические');
            $subcats[] = array('id' => 6, 'name' => 'Триллеры');
            $subcats[] = array('id' => 7, 'name' => 'Ужасы');
            $subcats[] = array('id' => 8, 'name' => 'Комедии');
            $subcats[] = array('id' => 9, 'name' => 'Биографические');
            $subcats[] = array('id' => 10, 'name' => 'Документальные');
            $subcats[] = array('id' => 11, 'name' => 'Русское кино');
            $subcats[] = array('id' => 12, 'name' => 'Анимация');
            $subcats[] = array('id' => 13, 'name' => 'Кока');
            $subcats[] = array('id' => 14, 'name' => 'Топ 250 IMBD');
            $subcats[] = array('id' => 15, 'name' => 'Топ 250 Кинопоиск');
            $subcats[] = array('id' => 16, 'name' => 'Топ 250 Амедиатека');
        }

        if ($subcat_id == 2) {
            $subcats[] = array('id' => 1, 'name' => 'Все');
            $subcats[] = array('id' => 2, 'name' => 'Детективы');
            $subcats[] = array('id' => 3, 'name' => 'Драмы');
            $subcats[] = array('id' => 4, 'name' => 'Фэнтези');
            $subcats[] = array('id' => 5, 'name' => 'Комедии');
            $subcats[] = array('id' => 6, 'name' => 'Исторические');
            $subcats[] = array('id' => 7, 'name' => 'Ужасы');
            $subcats[] = array('id' => 8, 'name' => 'Реалити');
            $subcats[] = array('id' => 9, 'name' => 'Эротика');
            $subcats[] = array('id' => 10, 'name' => 'Тележурналы');
            $subcats[] = array('id' => 11, 'name' => 'Мультфильмы');
            $subcats[] = array('id' => 12, 'name' => 'Боевики');
            $subcats[] = array('id' => 13, 'name' => 'Русские');
            $subcats[] = array('id' => 14, 'name' => 'Документальные');
            $subcats[] = array('id' => 15, 'name' => 'Топ 250 IMBD');
            $subcats[] = array('id' => 16, 'name' => 'Топ 250 Кинопоиск');
            $subcats[] = array('id' => 17, 'name' => 'Топ 250 Амедиатека');
        }

        if ($subcat_id == 3) {
            $subcats[] = array('id' => 1, 'name' => 'Топ 250 IMBD');
            $subcats[] = array('id' => 2, 'name' => 'Топ 250 Кинопоиск');
            $subcats[] = array('id' => 3, 'name' => 'Топ 250 Амедиатека');
        }

        return $subcats;

    }

    public function get_topcst_list()
    {
        hd_print("run function get_topcst_list");
        return $this->topcats;
    }

    public function get_loaded_series($serial_id, $season_id, &$plugin_cookies,$from_ndx,$lazy_limit)
    {
        hd_print("run function get_loaded_series");
        hd_print("get_loaded_series !!!!!!!!!!!!!");

        $this->session->ensure_logged_in($plugin_cookies);

        if (isset($this->movies[$season_id])) {
            return $this->movies[$season_id];
        }

        $serial = $this->fetch_serial($serial_id);
        $season = $serial['seasons'][$season_id];
        $series = $this->fetch_series_list($season_id,$from_ndx,$lazy_limit);

        $movie = new Movie($season_id);
        $movie->set_data(
            $season['name'],
            '', //$this->tv->get_channel(strval($xml->channels_id))->get_title(), //$xml->caption_original,
            $season['descr'],
            $serial['img'],
            '', //round(($xml->etm - $xml->tm)/60),
            $season['year'],
            '', //$xml->director,
            '', //$xml->scenario,
            '', //$xml->actors,
            '', //$xml->genres,
            '', //$xml->imdb,
            '', //$xml->kinopoisk,
            '', //$xml->age,
            '', //$xml->country,
            '' //$xml->budget
        );

        foreach ($series as $s) {
            $movie->add_series_data(
                $s['id'],
                $s['name'],
                $s['url'],
                true,
                $s['img']
            );
        }
        $this->movies[$season_id] = $movie;
        return $movie;
    }

    public function get_movie_left_button_caption(
        MediaURL $media_url, &$plugin_cookies)
    {
        return null;
    }

    public function get_movie_left_button_action(
        MediaURL $media_url, &$plugin_cookies)
    {
        return null;
    }

    public function get_vod_info(MediaURL $media_url, &$plugin_cookies)
    {
        hd_print("run function get_vod_info");
        $this->session->ensure_logged_in($plugin_cookies);

        //	$serial = $this->fetch_serial($media_url->serial_id);

        //	$season = $serial['seasons'][$media_url->serieslist_id];
        hd_print("get_vod_info fetch_series_list !!!!!!!!!!!!!!!!!");
        //	$series = $this->fetch_series_list($media_url->serieslist_id);

        $movie = $this->get_loaded_series($media_url->serial_id, $media_url->serieslist_id, $plugin_cookies,0,$this->lazy_limit);

        if ($movie === null) {
            // TODO: dialog?
            return null;
        }

        $sel_id = isset($media_url->serie_id) ?
            $media_url->serie_id : null;

        // history    
        $this->fetch_genre_list();
        if (!isset($this->toplist)) {
            $this->fetch_topmovie_list(null);
        }

        $i = 0;
        $no_top = 1;
        foreach ($this->toplist as $t) {
            if ($t == $media_url->serial_id) {
                $no_top = 0;
                break;
            }
            $i++;
            if ($i >= 3) {
                break;
            }
        }

        if ($no_top) {
            if (isset($plugin_cookies->prodhist)) {
                $prodhist = json_decode($plugin_cookies->prodhist, true);
            } else {
                $prodhist = array();
            }

            foreach ($prodhist as $k => $val) {
                if (($val['type'] == 2) && ($val['serial_id'] == $media_url->serial_id)) {
                    unset($prodhist[$k]);
                }
            }

            $len = array_unshift($prodhist, array(
                'type' => 2,
                'serial_id' => $media_url->serial_id));

            if ($len > 8) {
                array_pop($prodhist);
            }
            $plugin_cookies->prodhist = json_encode($prodhist);
            hd_print("prodhist: " . $plugin_cookies->prodhist);
        }


        return $movie->get_vod_info($sel_id, 3000);
    }

    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
        hd_print("run function get_folder_view");
        hd_print("******* get_folder_view ********** " . $media_url->serial_id);
//    	hd_print(print_r($media_url,true));

        // TODO по season_id надо определить есть сизоны или нет
        //
        // hd_print("----> count: " . count($this->folder_views));
        if (empty($media_url->serieslist_id) && !empty($media_url->serial_id)) {
            if ($this->getCountSeason($media_url->serial_id) == 0) $media_url->serieslist_id = $media_url->serial_id . ";0";
        }

        // hd_print("----> idx: $idx");
        if (isset($media_url->season_id)) {
            $movie = $this->get_loaded_series($media_url->serial_id, $media_url->season_id, $plugin_cookies);
            if ($movie === null) {
                // TODO: dialog?
                return null;
            }

            $left_button_caption = $this->get_movie_left_button_caption(
                $media_url, $plugin_cookies);
            hd_print("series url: " . $movie->series_list[0]->playback_url);
            $left_button_action = (count($movie->series_list) > 1) ?
                $this->get_movie_left_button_action($media_url, $plugin_cookies) :
                array
                (
                    GuiAction::handler_string_id => PLUGIN_TV_PLAY_ACTION_ID,
                    GuiAction::data =>
                        array
                        (
                            PluginOpenFolderActionData::media_url => $movie->series_list[0]->playback_url
                        )
                );

            $this->vod->get_movie_left_button_action(
                $media_url, $plugin_cookies);

            $has_right_button = $this->vod->is_favorites_supported();
            $right_button_caption = null;
            $right_button_action = null;

            hd_print("has_right_button = ".$has_right_button);

            if ($has_right_button)
            {
                $this->vod->ensure_favorites_loaded($plugin_cookies);

                $is_favorite = $this->vod->is_favorite_movie_id($movie->id);
                $right_button_caption = $is_favorite ?
                'Удалить из избранного' : 'Добавить в избранное';
                $right_button_action = UserInputHandlerRegistry::create_action(
                    $this, 'favorites',
                    array('movie_id' => $movie->id));
            }

            $listurl = MediaURL::encode(
                array(
                    'screen_id' => $this->id,//self::ID,//I24hAmediaListScreen::ID,
                    'serial_id' => $media_url->serial_id,
                    'serieslist_id' => $media_url->season_id,
                ));


            /*                        PluginRegularFolderView::view_params => array
                                    (
                                            ViewParams::num_cols => 1,
                                            ViewParams::num_rows => 10,
                                            ViewParams::paint_details => true,
                                            ViewParams::paint_item_info_in_details => true,
                                            ViewParams::zoom_detailed_icon => true,
                                            ViewParams::detailed_icon_scale_factor => 0.5,
                                            ViewParams::item_detailed_info_text_color => 10,
                                            ViewParams::item_detailed_info_auto_line_break => true
                                    ),*/


            $movie_folder_view = array
            (
                PluginMovieFolderView::movie => $movie->get_movie_array(),
                PluginMovieFolderView::left_button_caption => $left_button_caption,
                PluginMovieFolderView::left_button_action => $left_button_action,
                PluginMovieFolderView::has_right_button => $has_right_button,
                PluginMovieFolderView::right_button_caption => $right_button_caption,
                PluginMovieFolderView::right_button_action => $right_button_action,

                PluginMovieFolderView::params => array
                (
                    PluginFolderViewParams::background_url => I24hConfig::BG_PIC,  // 24h.tv
                ),
                PluginMovieFolderView::has_multiple_series => (count($movie->series_list) > 1),
                PluginMovieFolderView::series_media_url => $listurl,


                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 10,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
                    ViewParams::zoom_detailed_icon => true,
                    ViewParams::detailed_icon_scale_factor => 0.5,
                    ViewParams::item_detailed_info_text_color => 10,
                    ViewParams::item_detailed_info_auto_line_break => true
                ),

            );

            return array
            (
                PluginFolderView::multiple_views_supported => false,
                PluginFolderView::archive => null,
                PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_MOVIE,
                PluginFolderView::data => $movie_folder_view,
            );
        } else if (isset($media_url->serieslist_id)) {
            $folder_view =
                array
                (
                    PluginRegularFolderView::view_params => array
                    (
                        //ViewParams::num_cols => 1,
                        //ViewParams::num_rows => 12,
                        ViewParams::num_cols => 1,
                        ViewParams::num_rows => 4,

                        ViewParams::background_path => I24hConfig::BG_PIC,  // 24h.tv
                        ViewParams::background_width => 1920,
                        ViewParams::background_height => 1080,
                        ViewParams::background_order => 'before_all',

                    ),

                    PluginRegularFolderView::base_view_item_params => array
                    (
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 10,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::icon_sel_dx => 10,
                        ViewItemParams::icon_sel_dy => -5,
                        ViewItemParams::item_caption_dx => 300,
                        ViewItemParams::item_caption_dy => -30,
                        ViewItemParams::item_caption_sel_dy => -30,
                        ViewItemParams::item_caption_wrap_enabled => true,
                        ViewItemParams::icon_scale_factor => 0.8,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array(),

                );
        } else if (isset($media_url->serial_id)) {


//            hd_print("@@@@@@@@@  " . print_r($this->serials[$media_url->serial_id], true) . " @@@@@@@@@@@@@@@@");
            $folder_view = array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    /*ViewParams::num_cols => 1,
                    ViewParams::num_rows => 15,*/
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 6,
                    ViewParams::paint_details => true,
                    ViewParams::detailed_icon_scale_factor => 1.5,
                    //ViewParams::paint_item_info_in_details => true,
                    //ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,
                    ViewParams::item_detailed_info_rel_y => 315,//210,
                    ViewParams::background_path => I24hConfig::BG_PIC,//preg_replace('/&crop=true/','&blur=true', $this->serials[$media_url->serial_id]['img'] ),//I24hConfig::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all',
                    ViewParams::item_detailed_info_auto_line_break => true,
//                        ViewParams::content_box_width => 320,
//                        ViewParams::content_box_height => 200,
                    //ViewParams::content_box_width => 300,
                    /*ViewParams::content_box_x => 20,
                    ViewParams::content_box_y => 20,
                    ViewParams::content_box_width => 800,
                    ViewParams::content_box_width => 300*/
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => false,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 15,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_dx => 70,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ViewItemParams::item_caption_width => 1550,
                    ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                    ViewItemParams::item_detailed_icon_path => ''

                ),

                PluginRegularFolderView::not_loaded_view_item_params => array(),
            );
        } else if (isset($media_url->genre_id)) {
            $folder_view = array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (



                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 2,
                    ViewParams::paint_details => false,
                    ViewParams::orientation => 'horizontal',
                    ViewParams::sandwich_width => 380,
                    ViewParams::sandwich_height => 240,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                    ViewParams::background_path => I24hConfig::BG_PIC,
                    ViewParams::background_width => 1920,
                    ViewParams::background_height => 1080,
                    ViewParams::background_order => 'before_all'



                    //ViewParams::background_path => self::BG_PIC,
                    //ViewParams::background_width => 1920,
                    //ViewParams::background_height => 1080,
                    //ViewParams::background_order => 'before_all'
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_TOP,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::item_caption_wrap_enabled => true,
                    ViewItemParams::item_caption_dy => -40,
                    ViewItemParams::item_caption_sel_dy => -40,
                    ViewItemParams::icon_dy => 7,
                    ViewItemParams::icon_sel_dy => 7,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array
                (
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
                    ViewItemParams::item_detailed_icon_path => 'missing://',
                    //    	    	    ViewItemParams::icon_path => 'plugin_file://icons/placeholder.png',
                ),
            );
        } else {
            $folder_view =
                array
                (
                    PluginRegularFolderView::async_icon_loading => true,

                    PluginRegularFolderView::view_params => array
                    (


                        ViewParams::num_cols => 2,
                        ViewParams::num_rows => 8,
                        ViewParams::paint_details => false,
                        ViewParams::background_path => I24hConfig::BG_PIC,
                        ViewParams::background_width => 1920,
                        ViewParams::background_height => 1080,
                        ViewParams::background_order => 'before_all'


/*                        ViewParams::num_cols => 5,
                        ViewParams::num_rows => 4,
                        ViewParams::paint_details => false,
                        ViewParams::paint_sandwich => true,
                        ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                        ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                        ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
//                        ViewParams::sandwich_width => 395,
//                        ViewParams::sandwich_height => 220,
                        ViewParams::sandwich_width => 320,//290,//395,
                        ViewParams::sandwich_height => 168,//160,//220,
                        ViewParams::sandwich_icon_upscale_enabled => true,
                        ViewParams::sandwich_icon_keep_aspect_ratio => false,
                        ViewParams::background_path => I24hConfig::BG_PIC,
                        ViewParams::background_width => 1920,
                        ViewParams::background_height => 1080,
                        ViewParams::background_order => 'before_all'
*/
                    ),

                    PluginRegularFolderView::base_view_item_params => array
                    (

                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 15,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_dx => 70,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai'


/*
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::item_layout => HALIGN_CENTER,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550,
//                        ViewItemParams::icon_width => 395,
#                        ViewItemParams::icon_height => 185,
//                        ViewItemParams::icon_height => 220,
                        ViewItemParams::icon_width => 320,//290,//395,
                        ViewItemParams::icon_height => 168,//160,//220,

                        ViewItemParams::item_paint_caption => false,
                        ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
                        ViewItemParams::item_detailed_icon_path => 'missing://',
*/
                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array(),
                );


        }

        //$folder_view = $this->folder_views[$idx];

        $folder_view[PluginRegularFolderView::actions] =
            $this->get_action_map($media_url, $plugin_cookies);

        $folder_view[PluginRegularFolderView::initial_range] =
            $this->get_folder_range($media_url, 0, $plugin_cookies);

        $archive = $this->get_archive($media_url);
        $archive_def = is_null($archive) ? null :
            $archive->get_archive_def();

        return array
        (
            PluginFolderView::multiple_views_supported => 0,
            PluginFolderView::archive => $archive_def,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::data => $folder_view
        );
    }


    public function getCountSeason($season_id)
    {
        $doc = HD::http_get_document(sprintf($this->session->get_api_server() . I24hConfig::VIDEO_SERIES_LIST,
            $season_id, $this->session->get_token()));
        if (is_null($doc))
            throw new Exception('Can not fetch topmovie list');
        $xml = simplexml_load_string($doc);

        if ($xml === false) {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }

        if ($xml->getName() !== 'root') {
            hd_print("Error: unexpected node '" . $xml->getName() . "'. Expected: 'response'");
            throw new Exception('Invalid XML document');
        }

        foreach ($xml->children() as $c) {
            return strval($c->season);
        }


    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
//        hd_print('Video teka: handle_user_input:');
//        foreach ($user_input as $key => $value)
//            hd_print("  $key => $value");
      if ($user_input->control_id == 'play_video') {
            $this->is_user_subcribers();
            if ($this->allow_view) {
                return ActionFactory::vod_play();
            } else {
                $defs = array();
                $tarifs = implode(", ", $this->allow_in_packets);

                ControlFactory::add_label($defs, null, 'К сожалению, у Вас нет доступа к "'.$this->name.'"!');
                ControlFactory::add_vgap($defs, 40);
                ControlFactory::add_label($defs, null, 'Для доступа к "'.$this->name.'" зайдите в личный кабинет');
                ControlFactory::add_label($defs, null, 'и выберите один из следующих тарифов:');
                ControlFactory::add_vgap($defs, 40);
                ControlFactory::add_label($defs, null, $tarifs);
                ControlFactory::add_vgap($defs, 40);
                ControlFactory::add_label($defs, null, 'Для выбора тарифа, нажмите кнопку "Подключить".');
                ControlFactory::add_vgap($defs, 40);
                ControlFactory::add_button_close($defs, $this, array('button_caption_centered'=>true), 'to_tariffs', null, ' Подключить', 300);
                ControlFactory::add_button_close($defs, $this, array('button_caption_centered'=>true), 'cancel', null, '    Отмена', 300);

                return ActionFactory::show_dialog('Внимание!', $defs);
            }
        }else if ($user_input->control_id == 'to_tariffs'){
            return ActionFactory::open_folder(I24hPrivateScreen::get_media_url_str(''),'Управление тарифами');
        }
    }
}
///////////////////////////////////////////////////////////////////////////
?>
